;****************************************************************************
;****************************************************************************
;*
;* vic6569.n
;*
;****************************************************************************
;****************************************************************************





;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO:
;* BASE_LINE_COUNTER is set in cycle 62 but one cycle later register 12 is
;  updated, is this correct ?
;* position of the text window, test with cycle exact manipulation of $d020
;* are sprite positions correct ?
;* fix DMA timing misbehavior
;* sprite collisions
;* lightpen
;* decode_overscan
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!




%define VIC6569_N
%include "vic6569.i"
%include "core.i"
%include "c64link.i"





;****************************************************************************
;****************************************************************************
;*
;* PART 1: assign's & define's
;*
;****************************************************************************
;****************************************************************************





%assign REGISTERS_SIZE		VIC6569_REGISTERS_SIZE
%assign LINES_PER_FRAME		VIC6569_LINES_PER_FRAME
%assign CYCLES_PER_LINE		VIC6569_CYCLES_PER_LINE
%assign CHANGE_LOG_SIZE		VIC6569_CHANGE_LOG_SIZE



%define	MODULID			VIC6569_MODULID
%define HIGH_BITS		VIC6569_HIGH_BITS
%define BASE			VIC6569_BASE
%define DECODE			VIC6569_DECODE



%define BASE_STATE			VIC6569_BASE_STATE
%define BASE_EXECUTE_CYCLE		VIC6569_BASE_EXECUTE_CYCLE
%define BASE_EXECUTE_CYCLE_SWITCH	VIC6569_BASE_EXECUTE_CYCLE_SWITCH
%define BASE_CYCLE_COUNTER		VIC6569_BASE_CYCLE_COUNTER
%define BASE_ECM_ADDRESS_MASK		VIC6569_BASE_ECM_ADDRESS_MASK
%define BASE_EXTRA_VIDEO_BYTE		VIC6569_BASE_EXTRA_VIDEO_BYTE
%define BASE_DMA_DELAY_COUNTER		VIC6569_BASE_DMA_DELAY_COUNTER
%define BASE_SPRITE_DMA_MASK		VIC6569_BASE_SPRITE_DMA_MASK
%define BASE_SPRITE_DMA_MASK_BASE	VIC6569_BASE_SPRITE_DMA_MASK_BASE
%define BASE_SPRITE_DMA_MASK_LAST	VIC6569_BASE_SPRITE_DMA_MASK_LAST
%define BASE_SPRITE_Y_EXPAND_MASK	VIC6569_BASE_SPRITE_Y_EXPAND_MASK
%define BASE_SPRITE_DMA_CYCLES		VIC6569_BASE_SPRITE_DMA_CYCLES
%define BASE_SPRITE_DMA_CYCLES_BASE	VIC6569_BASE_SPRITE_DMA_CYCLES_BASE
%define BASE_SPRITE_CACHE_OFFSET	VIC6569_BASE_SPRITE_CACHE_OFFSET
%define BASE_SPRITE_COUNTERS		VIC6569_BASE_SPRITE_COUNTERS
%define BASE_VIDEO_ADDRESS		VIC6569_BASE_VIDEO_ADDRESS
%define BASE_DATA_ADDRESS		VIC6569_BASE_DATA_ADDRESS
%define BASE_VIDEO_COUNTER		VIC6569_BASE_VIDEO_COUNTER
%define BASE_ROW_COUNTER		VIC6569_BASE_ROW_COUNTER
%define BASE_VIDEO_CACHE_OFFSET		VIC6569_BASE_VIDEO_CACHE_OFFSET
%define BASE_CHANGE_LOG_OFFSET		VIC6569_BASE_CHANGE_LOG_OFFSET
%define BASE_LINE_TIMESTAMP		VIC6569_BASE_LINE_TIMESTAMP
%define BASE_LINE_COUNTER		VIC6569_BASE_LINE_COUNTER
%define BASE_LINE_LATCH			VIC6569_BASE_LINE_LATCH
%define BASE_BORDER_LEFT		VIC6569_BASE_BORDER_LEFT
%define BASE_BORDER_RIGHT		VIC6569_BASE_BORDER_RIGHT
%define BASE_BORDER_TOP			VIC6569_BASE_BORDER_TOP
%define BASE_BORDER_BUTTOM		VIC6569_BASE_BORDER_BUTTOM
%define BASE_FRAME_OFFSET_LAST		VIC6569_BASE_FRAME_OFFSET_LAST
%define BASE_FRAME_OFFSET		VIC6569_BASE_FRAME_OFFSET
%define BASE_FRAME_OFFSET_UNUSED	VIC6569_BASE_FRAME_OFFSET_UNUSED
%define BASE_FRAME_OFFSET_NEXT		VIC6569_BASE_FRAME_OFFSET_NEXT
%define BASE_REGISTERS			VIC6569_BASE_REGISTERS
%define BASE_FRAME			VIC6569_BASE_FRAME

%define DECODE_X_START			VIC6569_DECODE_X_START
%define DECODE_X_END			VIC6569_DECODE_X_END
%define DECODE_Y_START			VIC6569_DECODE_Y_START
%define DECODE_Y_END			VIC6569_DECODE_Y_END
%define DECODE_SCREEN_START		VIC6569_DECODE_SCREEN_START
%define DECODE_SCREEN			VIC6569_DECODE_SCREEN
%define DECODE_SCREEN_LINE_LENGTH	VIC6569_DECODE_SCREEN_LINE_LENGTH
%define DECODE_LINES			VIC6569_DECODE_LINES
%define DECODE_LINES_LIST		VIC6569_DECODE_LINES_LIST
%define DECODE_FUNCTION			VIC6569_DECODE_FUNCTION
%define DECODE_FRAME_OFFSET_LAST	VIC6569_DECODE_FRAME_OFFSET_LAST
%define DECODE_FRAME_OFFSET		VIC6569_DECODE_FRAME_OFFSET
%define DECODE_STATE			VIC6569_DECODE_STATE
%define DECODE_REGISTERS		VIC6569_DECODE_REGISTERS
%define DECODE_Z_BUFFER			VIC6569_DECODE_Z_BUFFER
%define DECODE_COLOR_INDEX0		VIC6569_DECODE_COLOR_INDEX0
%define DECODE_COLOR_INDEX1		VIC6569_DECODE_COLOR_INDEX1
%define DECODE_COLOR_INDEX2		VIC6569_DECODE_COLOR_INDEX2
%define DECODE_COLOR_INDEX3		VIC6569_DECODE_COLOR_INDEX3
%define DECODE_LOOKUP_TABLE1		VIC6569_DECODE_LOOKUP_TABLE1
%define DECODE_Z_LAYER			VIC6569_DECODE_Z_LAYER
%define DECODE_SPRITE_Z_LAYER		VIC6569_DECODE_SPRITE_Z_LAYER
%define DECODE_LINE_CYCLE		VIC6569_DECODE_LINE_CYCLE
%define DECODE_LOOKUP_TABLE2		VIC6569_DECODE_LOOKUP_TABLE2
%define DECODE_SPRITE_DMA_MASK_LAST	VIC6569_DECODE_SPRITE_DMA_MASK_LAST
%define DECODE_LINES_MARKED		VIC6569_DECODE_LINES_MARKED




%assign STATE_DISPLAY_DISABLE			VIC6569_STATE_DISPLAY_DISABLE
%assign STATE_DISPLAY_MODE			VIC6569_STATE_DISPLAY_MODE
%assign STATE_BORDER_MAIN			VIC6569_STATE_BORDER_MAIN
%assign STATE_BORDER_VERTICAL			VIC6569_STATE_BORDER_VERTICAL
%assign STATE_FORCE_DECODING			VIC6569_STATE_FORCE_DECODING
%assign STATE_BAD_LINE				VIC6569_STATE_BAD_LINE
%assign STATE_BAD_LINE_EXPECTED			VIC6569_STATE_BAD_LINE_EXPECTED
%assign STATE_ACCESS_GRANTED			VIC6569_STATE_ACCESS_GRANTED
%assign STATE_VIDEO_ADDRESS_IN_RAM		VIC6569_STATE_VIDEO_ADDRESS_IN_RAM
%assign STATE_RESET_IN_PROGRESS			VIC6569_STATE_RESET_IN_PROGRESS



%macro GET_CYCLES 0
			call	core_get_c64_cycles
%endmacro





;****************************************************************************
;****************************************************************************
;*
;* PART 2: Initialisation & Management Routines
;*
;****************************************************************************
;****************************************************************************





;****************************************************************************
;* vic6569_initialze ********************************************************
;****************************************************************************
section .text
vic6569_initialize:
			;-------------------------------
			;generate ab__decode_table.hires
			;-------------------------------

			xor	byte  al, al
			xor	dword ebx, ebx
			mov	dword ebp, ab__decode_table.hires
.hires:			mov	byte  ah, al
			rol	byte  ah, 1
			mov	byte  bl, ah
			and	byte  bl, 1
			mov	byte  cl, [.ab__offset_table + ebx]
			mov	byte  [ebp], cl
			rol	byte  ah, 1
			mov	byte  bl, ah
			and	byte  bl, 1
			mov	byte  cl, [.ab__offset_table + ebx + 4]
			mov	byte  [ebp + 1], cl
			rol	byte  ah, 1
			mov	byte  bl, ah
			and	byte  bl, 1
			mov	byte  cl, [.ab__offset_table + ebx + 8]
			mov	byte  [ebp + 2], cl
			rol	byte  ah, 1
			mov	byte  bl, ah
			and	byte  bl, 1
			mov	byte  cl, [.ab__offset_table + ebx + 12]
			mov	byte  [ebp + 3], cl
			rol	byte  ah, 1
			mov	byte  bl, ah
			and	byte  bl, 1
			mov	byte  cl, [.ab__offset_table + ebx + 16]
			mov	byte  [ebp + 4], cl
			rol	byte  ah, 1
			mov	byte  bl, ah
			and	byte  bl, 1
			mov	byte  cl, [.ab__offset_table + ebx + 20]
			mov	byte  [ebp + 5], cl
			rol	byte  ah, 1
			mov	byte  bl, ah
			and	byte  bl, 1
			mov	byte  cl, [.ab__offset_table + ebx + 24]
			mov	byte  [ebp + 6], cl
			rol	byte  ah, 1
			mov	byte  bl, ah
			and	byte  bl, 1
			mov	byte  cl, [.ab__offset_table + ebx + 28]
			mov	byte  [ebp + 7], cl
			add	dword ebp, 8
			inc	byte  al
			jnz	near  .hires

			;-----------------------------
			;generate ab__decode_table.mcm
			;-----------------------------

			xor	byte  al, al
			xor	dword ebx, ebx
			mov	dword ebp, ab__decode_table.mcm
.mcm:			mov	byte  ah, al
			rol	byte  ah, 2
			mov	byte  bl, ah
			and	byte  bl, 3
			mov	byte  cl, [.ab__offset_table + ebx]
			mov	byte  ch, [.ab__offset_table + ebx + 4]
			mov	byte  [ebp], cl
			mov	byte  [ebp + 1], ch
			rol	byte  ah, 2
			mov	byte  bl, ah
			and	byte  bl, 3
			mov	byte  cl, [.ab__offset_table + ebx + 8]
			mov	byte  ch, [.ab__offset_table + ebx + 12]
			mov	byte  [ebp + 2], cl
			mov	byte  [ebp + 3], ch
			rol	byte  ah, 2
			mov	byte  bl, ah
			and	byte  bl, 3
			mov	byte  cl, [.ab__offset_table + ebx + 16]
			mov	byte  ch, [.ab__offset_table + ebx + 20]
			mov	byte  [ebp + 4], cl
			mov	byte  [ebp + 5], ch
			rol	byte  ah, 2
			mov	byte  bl, ah
			and	byte  bl, 3
			mov	byte  cl, [.ab__offset_table + ebx + 24]
			mov	byte  ch, [.ab__offset_table + ebx + 28]
			mov	byte  [ebp + 6], cl
			mov	byte  [ebp + 7], ch
			add	dword ebp, 8
			inc	byte  al
			jnz	.mcm
			ret

.ab__offset_table:	db	VICDECODE_COLOR_INDEX0
			db	VICDECODE_COLOR_INDEX1
			db	VICDECODE_COLOR_INDEX2
			db	VICDECODE_COLOR_INDEX3
			db	(VICDECODE_COLOR_INDEX0 + 1)
			db	VICDECODE_COLOR_INDEX1
			db	VICDECODE_COLOR_INDEX2
			db	VICDECODE_COLOR_INDEX3
			db	(VICDECODE_COLOR_INDEX0 + 2)
			db	VICDECODE_COLOR_INDEX1
			db	VICDECODE_COLOR_INDEX2
			db	VICDECODE_COLOR_INDEX3
			db	(VICDECODE_COLOR_INDEX0 + 3)
			db	VICDECODE_COLOR_INDEX1
			db	VICDECODE_COLOR_INDEX2
			db	VICDECODE_COLOR_INDEX3
			db	(VICDECODE_COLOR_INDEX0 + 4)
			db	VICDECODE_COLOR_INDEX1
			db	VICDECODE_COLOR_INDEX2
			db	VICDECODE_COLOR_INDEX3
			db	(VICDECODE_COLOR_INDEX0 + 5)
			db	VICDECODE_COLOR_INDEX1
			db	VICDECODE_COLOR_INDEX2
			db	VICDECODE_COLOR_INDEX3
			db	(VICDECODE_COLOR_INDEX0 + 6)
			db	VICDECODE_COLOR_INDEX1
			db	VICDECODE_COLOR_INDEX2
			db	VICDECODE_COLOR_INDEX3
			db	(VICDECODE_COLOR_INDEX0 + 7)
			db	VICDECODE_COLOR_INDEX1
			db	VICDECODE_COLOR_INDEX2
			db	VICDECODE_COLOR_INDEX3

section .bss
			alignb	4
ab__decode_table:		
.hires:			resb	00800h
.mcm:			resb	00800h



;****************************************************************************
;* vic6569_exit *************************************************************
;****************************************************************************
section .text
vic6569_exit:
			ret



;****************************************************************************
;* vic6569_instance_initialize **********************************************
;****************************************************************************
section .text
vic6569_instance_initialize:
			INSTANCE_INITIALIZE  tvic6569_size



;****************************************************************************
;* vic6569_instance_exit ****************************************************
;****************************************************************************
section .text
vic6569_instance_exit:
			ret



;****************************************************************************
;* vic6569_screen_initialize ************************************************
;****************************************************************************
;* [1]=>  pointer to decoded lines list
;* eax=>  x start
;* ebx=>  y start
;* ecx=>  x length
;* edx=>  y length
;* edi=>  pointer to framebuffer
;* ebp=>  virtual x resolution
;* <=eax  return status
;****************************************************************************
section .text
vic6569_screen_initialize:
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: use a pointer to a struct as input parameter
;      DECODE_LINES is not set, but this pointer should be initialized
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			shr	dword eax, 3
			shr	dword ecx, 3
			cmp	dword eax, (CYCLES_PER_LINE - 1)
			ja	near  .failed
			cmp	dword ebx, (LINES_PER_FRAME - 1)
			ja	near  .failed
			mov	dword [DECODE_X_START], eax
			mov	dword [DECODE_Y_START], ebx
			cmp	dword ecx, CYCLES_PER_LINE
			ja	near  .failed
			cmp	dword edx, LINES_PER_FRAME
			ja	near  .failed
			add	dword eax, ecx
			add	dword ebx, edx
			cmp	dword eax, CYCLES_PER_LINE
			ja	near  .failed
			cmp	dword ebx, LINES_PER_FRAME
			ja	near  .failed
			mov	dword [DECODE_SCREEN_LINE_LENGTH], ebp
			mov	dword [DECODE_X_END], eax
			mov	dword [DECODE_Y_END], ebx
			mov	dword eax, ebp
			mov	dword ebx, [DECODE_X_START]
			mul	dword [DECODE_Y_START]
			shl	dword ebx, 3
			add	dword eax, ebx
			sub	dword edi, eax
			mov	dword [DECODE_SCREEN_START], edi
			mov	dword ebx, [esp + 4]
			mov	dword [DECODE_SCREEN], edi
			mov	dword [DECODE_LINES_LIST], ebx

			;--------------------
			;decode current frame
			;--------------------

			xor	dword eax, eax
			mov	dword ecx, (LINES_PER_FRAME / 4)
			dec	dword eax
			lea	dword edi, [DECODE_LINES_MARKED]
			cld
			rep stosd
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: DECODE_LINES is a pointer!
			xor	dword eax, eax
			mov	dword [DECODE_LINES], eax
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			call	decode_screen
			xor	dword eax, eax
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: DECODE_LINES is a pointer!
			mov	dword ebx, [DECODE_LINES]
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			mov	dword ecx, [DECODE_LINES_LIST]
			mov	dword [ecx + 4 * ebx], eax
			ret

			;-----------------------------------------------
			;set the first line to be decoded out of the VIC
			;range, so no decoding is done
			;-----------------------------------------------

.failed:		xor	dword eax, eax
			dec	dword eax
			mov	dword [DECODE_Y_START], eax
			mov	dword eax, -CORE_ERROR_BAD_VALUE
			ret





;****************************************************************************
;****************************************************************************
;*
;* PART 3: Signal Routines
;*
;****************************************************************************
;****************************************************************************





;****************************************************************************
;* vic6569_reset_hard *******************************************************
;****************************************************************************
section .text
vic6569_reset_hard:
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			push	dword edi

			;-------------------------------------
			;clear BASE and set BASE_EXECUTE_CYCLE
			;-------------------------------------

			xor	dword eax, eax
			mov	dword ecx, VICBASE_SIZE
			lea	dword edi, [BASE]
			cld
			rep stosb

			;-------------------------------------------------
			;initialize variables which must have other values
			;than zero
			;-------------------------------------------------

			mov	dword eax, bus_cycle_0_new_frame
			mov	dword ebx, (STATE_BORDER_MAIN | STATE_BORDER_VERTICAL)
			mov	dword ecx, VICLINE_SIZE
			mov	dword edx, (2 * VICLINE_SIZE)
			mov	dword [BASE_EXECUTE_CYCLE], eax
			mov	dword [BASE_STATE], ebx
			xor	dword eax, eax
			mov	dword [BASE_FRAME_OFFSET], ecx
			inc	dword eax
			mov	dword [BASE_FRAME_OFFSET_UNUSED], edx
			add	dword edx, ecx
			mov	dword [BASE_VIDEO_CACHE_OFFSET], eax
			mov	dword [BASE_FRAME_OFFSET_NEXT], edx
			GET_CYCLES
			sub	dword eax, byte 1
			sbb	dword edx, byte 0
			mov	dword [BASE_LINE_TIMESTAMP], eax
			mov	dword [BASE_LINE_TIMESTAMP + 4], edx

			;-------------------------------------------------
			;clear all registers with vic6569_write, this
			;is the best way to initialize all other variables
			;-------------------------------------------------

			or	dword [BASE_STATE], STATE_RESET_IN_PROGRESS
			xor	dword ebx, ebx
			xor	dword eax, eax
			mov	byte  bl, (REGISTERS_SIZE - 1)
.clear_registers:	call	vic6569_write
			dec	dword ebx
			jns	.clear_registers
			and	dword [BASE_STATE], (NOT32 - STATE_RESET_IN_PROGRESS)

			;-------------------------------------------
			;misplaced here, should only be necesarry on
			;vic6569_instance_initialize
			;-------------------------------------------

			mov	dword eax, 003020100h
			mov	dword ebx, 007060504h
			mov	dword ecx, 00b0a0908h
			mov	dword edx, 00f0e0d0ch
			mov	dword [DECODE_LOOKUP_TABLE1], eax
			mov	dword [DECODE_LOOKUP_TABLE1 + 4], ebx
			mov	dword [DECODE_LOOKUP_TABLE1 + 8], ecx
			mov	dword [DECODE_LOOKUP_TABLE1 + 12], edx
			mov	dword [DECODE_LOOKUP_TABLE2], eax
			mov	dword [DECODE_LOOKUP_TABLE2 + 4], ebx
			mov	dword [DECODE_LOOKUP_TABLE2 + 8], ecx
			mov	dword [DECODE_LOOKUP_TABLE2 + 12], edx

			pop	dword edi
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			jmp	vic6569_reset_soft



;****************************************************************************
;* vic6569_reset_soft *******************************************************
;****************************************************************************
section .text
vic6569_reset_soft:
			push	dword eax
			push	dword ebx
			push	dword ebp
			or	dword [BASE_STATE], STATE_RESET_IN_PROGRESS
			xor	dword eax, eax
			mov	byte  bl, 01ah
			call	vic6569_write
			and	dword [BASE_STATE], (NOT32 - STATE_RESET_IN_PROGRESS)

			;---------------------------------------------------
			;we have a problem with the HIGH_BITS in some
			;situations on reset (HIGH_BITS seem to hold the old
			;value before reset, the real reason is up to now
			;unknown ;-). So i clear them here
			;---------------------------------------------------

			xor	dword eax, eax
			mov	dword [HIGH_BITS], eax

			pop	dword ebp
			pop	dword ebx
			pop	dword eax
			ret



;****************************************************************************
;* vic6569_signal_high_bits *************************************************
;****************************************************************************
;* eax=>  high address bits
;****************************************************************************
section .text
vic6569_signal_high_bits:
			push	dword eax
			and	dword eax, 000000003h
			shl	dword eax, 14
			mov	dword [HIGH_BITS], eax
			pop	dword eax
			jmp	address_recalculate





;****************************************************************************
;****************************************************************************
;*
;* PART 4: Read/Write Functions
;*
;****************************************************************************
;****************************************************************************





;****************************************************************************
;* check_bad_line ***********************************************************
;****************************************************************************
section .text
check_bad_line:
			push	dword eax
			push	dword ebx
			mov	dword eax, [BASE_STATE]
			mov	dword ebx, [BASE_LINE_COUNTER]
			and	dword eax, (NOT32 - STATE_BAD_LINE_EXPECTED)
			test	dword eax, STATE_DISPLAY_DISABLE
			jnz	.no_bad_line_expected
			cmp	dword ebx, 48
			jb	.no_bad_line_expected
			cmp	dword ebx, 247
			ja	.no_bad_line_expected
			mov	byte  bh, [BASE_REGISTERS + 011h]
			and	dword ebx, 000000707h
			cmp	byte  bh, bl
			jne	.no_bad_line_expected
			or	dword eax, STATE_BAD_LINE_EXPECTED
.no_bad_line_expected:	pop	dword ebx
			mov	dword [BASE_STATE], eax
			pop	dword eax
			ret



;****************************************************************************
;* get_cycle_function *******************************************************
;****************************************************************************
;* eax=>  cycle function
;* <=eax  replaced cycle function (if found)
;****************************************************************************
section .text
get_cycle_function:
			push	dword ebx
			push	dword ecx
			xor	dword ecx, ecx
			dec	dword ecx
.loop:			inc	dword ecx
			mov	dword ebx, [.ap__cycle_functions + 8 * ecx]
			test	dword ebx, ebx
			jz	.end
			cmp	dword ebx, eax
			jne	.loop
			mov	dword eax, [.ap__cycle_functions + 8 * ecx + 4]
.end:			pop	dword ecx
			pop	dword ebx
			ret

			align	4
.ap__cycle_functions:	dd	bus_cycle_11_idle, bus_cycle_11
			dd	bus_cycle_12_idle, bus_cycle_12
			dd	bus_cycle_13_idle, bus_cycle_13
			dd	bus_cycle_14_idle, bus_cycle_14
			dd	bus_cycle_15_idle, bus_cycle_15
			dd	bus_cycle_16_idle, bus_cycle_16
			dd	bus_cycle_17_idle, bus_cycle_17
			dd	0, 0



;****************************************************************************
;* check_bad_line_switch ****************************************************
;****************************************************************************
section .text
check_bad_line_switch:
			test	dword [BASE_STATE], STATE_BAD_LINE_EXPECTED
			jz	.end

			;--------------------------------------
			;check if we have to switch the current
			;BASE_EXECUTE_CYCLE routine
			;--------------------------------------

			push	dword eax
			push	dword ebx
			mov	dword eax, [BASE_EXECUTE_CYCLE]
			mov	dword ebx, eax
			call	get_cycle_function
			cmp	dword eax, ebx
			je	.no_switch
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_switch
			mov	dword [BASE_EXECUTE_CYCLE_SWITCH], ebx
.no_switch:		pop	dword ebx
			pop	dword eax
.end:			ret



;****************************************************************************
;* address_recalculate ******************************************************
;****************************************************************************
section .text
address_recalculate:
			push	dword eax
			push	dword ebx
			push	dword ecx
			xor	dword ebx, ebx
			xor	dword ecx, ecx
			mov	byte  bl, [BASE_REGISTERS + 018h]
			mov	dword eax, [HIGH_BITS]
			mov	byte  cl, bl
			and	byte  bl, 0f0h
			and	byte  cl, 00eh
			test	byte  [BASE_REGISTERS + 011h], 020h
			jz	.no_bitmap
			and	byte  cl, 008h
.no_bitmap:		shl	dword ebx, 6
			shl	dword ecx, 10
			or	dword ebx, eax
			or	dword ecx, eax
			mov	dword [BASE_VIDEO_ADDRESS], ebx
			mov	dword [BASE_DATA_ADDRESS], ecx
			mov	dword ebx, [BASE_STATE]
			mov	dword eax, [BASE_VIDEO_ADDRESS]
			or	dword ebx, STATE_VIDEO_ADDRESS_IN_RAM
			test	dword eax, 06000h
			jnz	.video_address_in_ram
			test	dword eax, 01000h
			jz	.video_address_in_ram
			and	dword ebx, (NOT32 - STATE_VIDEO_ADDRESS_IN_RAM)
.video_address_in_ram:	mov	dword [BASE_STATE], ebx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret


;****************************************************************************
;* change_log_write *********************************************************
;****************************************************************************
;* al==>  byte to write to register
;* ebp=>  register
;****************************************************************************
section .text
change_log_write:
			test	dword [BASE_STATE], STATE_RESET_IN_PROGRESS
			jnz	.register_unchanged
			cmp	byte  [BASE_REGISTERS + ebp], al
			je	.register_unchanged
			push	dword eax
			push	dword ebx
			push	dword edx
			push	dword ebp
			mov	dword edx, [BASE_CHANGE_LOG_OFFSET]
			mov	dword ebx, ebp
			mov	dword ebp, [BASE_FRAME_OFFSET]
			shl	dword ebx, 16
			inc	dword edx
			mov	byte  bh, al
			mov	dword [BASE_CHANGE_LOG_OFFSET], edx
			lea	dword ebp, [VICLINE_CHANGE_LOG + ebp + 4 * edx - 4]

			;------------------------------------------------
			;the smallest difference we should ever get is 1,
			;because the timestamp is generated before the
			;cycle counters are increased
			;------------------------------------------------

			GET_CYCLES
			sub	dword eax, [BASE_LINE_TIMESTAMP]
			dec	dword eax
%ifdef VIC6569_ASSERTION
%ifdef VIC6569_ASSERTION_CHANGE_LOG_WRITE
			js	.error
			sbb	dword edx, [BASE_LINE_TIMESTAMP + 4]
			jnz	.error
			cmp	dword eax, CYCLES_PER_LINE
			jb	.ok
.error:			mov	dword ebx, eax
			mov	dword eax, [MODULID]
			mov	dword ecx, __LINE__
			jmp	core_assertion
.ok:
%endif
%endif
			mov	byte  bl, al
			mov	dword [BASE_FRAME + ebp], ebx
			pop	dword ebp
			pop	dword edx
			pop	dword ebx
			pop	dword eax
.register_unchanged:	ret



;****************************************************************************
;* vic6569_read *************************************************************
;****************************************************************************
section .text
vic6569_read:
			mov	dword ebp, ebx
			and	dword ebp, 03fh
			cmp	dword ebp, 02eh
			ja	.read_rubbish
			xor	byte  ah, ah
			mov	byte  al, [BASE_REGISTERS + ebp]
			cmp	dword ebp, 01eh
			jne	.read_1
			mov	byte  [BASE_REGISTERS + ebp], ah
			ret
.read_1:		cmp	dword ebp, 01fh
			jne	.read_2
			mov	byte  [BASE_REGISTERS + ebp], ah
.read_2:		ret
.read_rubbish:		mov	byte  al, 0ffh
			ret



;****************************************************************************
;* vic6569_write ************************************************************
;****************************************************************************
section .text
vic6569_write:
			mov	dword ebp, ebx
			and	dword ebp, 03fh
			jmp	dword [.ap__registers + 4 * ebp]

section .rodata
			align	4
.ap__registers:		dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position

			dd	write_sprite_position
			dd	write_register_11
			dd	write_register_12
			dd	write_ignore
			dd	write_ignore
			dd	write_register_15
			dd	write_register_16
			dd	write_register_17
			dd	write_register_18
			dd	write_register_19
			dd	write_register_1a
			dd	write_register_1b
			dd	write_register_1c
			dd	write_register_1d
			dd	write_register_1e
			dd	write_register_1f

			dd	write_color
			dd	write_color
			dd	write_color
			dd	write_color
			dd	write_color
			dd	write_sprite_mcm
			dd	write_sprite_mcm
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_ignore

			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore

section .text
write_ignore:
			ret

write_sprite_position:
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: should i call change_log_write for sprite positions ?
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;			call	change_log_write
			mov	byte  [BASE_REGISTERS + ebp], al
			ret

write_register_11:
			mov	byte  ah, al
			push	dword ebx
			and	byte  al, 07fh
			call	change_log_write
			mov	byte  bl, [BASE_REGISTERS + 011h]
			rol	byte  ah, 1
			and	byte  bl, 080h
			and	byte  ah, 001h
			or	byte  al, bl
			mov	byte  [BASE_REGISTERS + 011h], al
			mov	byte  [BASE_LINE_LATCH + 1], ah
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: extra IRQ Handling like write_register_12 ???
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			mov	dword ebx, 55
			mov	dword ebp, 247
			test	byte  al, 008h
			jz	.text_lines_24
			mov	dword ebx, 51
			mov	dword ebp, 251
.text_lines_24:		mov	dword [BASE_BORDER_TOP], ebx
			mov	dword [BASE_BORDER_BUTTOM], ebp
			mov	dword ebx, [BASE_LINE_COUNTER]
			mov	dword eax, [BASE_STATE]
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: DMA should stay enabled, if it was enabled before disabling in line 48
;      result should be a disabled screen but DMA enabled ==> VIC-Article
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			cmp	dword ebx, 48
			ja	.end
			and	dword eax, (NOT32 - STATE_DISPLAY_DISABLE)
			test	byte  [BASE_REGISTERS + 011h], 010h
			jnz	.end
			or	dword eax, STATE_DISPLAY_DISABLE
.end:			mov	byte  bl, 0ffh
			test	byte  [BASE_REGISTERS + 011h], 040h
			jz	.no_ecm
			mov	byte  bl, 0f9h
.no_ecm:		mov	byte  [BASE_ECM_ADDRESS_MASK], bl
			mov	dword [BASE_STATE], eax
			pop	dword ebx
			call	check_bad_line
			call	check_bad_line_switch
			jmp	address_recalculate

write_register_12:
			mov	byte  [BASE_LINE_LATCH], al
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: is this extra IRQ Handling correct ???
;      turrican-side1.d64 likes it ;-)
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			push	dword ebx
			mov	dword eax, [BASE_LINE_COUNTER]
			mov	byte  bl, [BASE_REGISTERS + 019h]
			cmp	dword eax, [BASE_LINE_LATCH]
			jne	.line_latch_differs
			mov	byte  al, [BASE_REGISTERS + 01ah]
			or	byte  bl, 001h
			test	byte  al, 001h
			jz	.no_irq
			or	byte  bl, 080h
			mov	byte  al, 1
			call	c64link_vic_irq
.no_irq:		mov	byte  [BASE_REGISTERS + 019h], bl
.line_latch_differs:	pop	dword ebx
			ret

write_register_15:
			call	change_log_write
			mov	byte  [BASE_REGISTERS + 015h], al
			ret

write_register_16:
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: state of the reset bit ?
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			or	byte  al, 0c0h
			call	change_log_write
			push	dword ebx
			mov	byte  [BASE_REGISTERS + 016h], al
			mov	dword ebx, 16
			mov	dword ebp, 55		;54 + 1
			test	byte  al, 008h
			jz	.text_rows_38
			mov	dword ebx, 15
			mov	dword ebp, 56		;55 + 1
.text_rows_38:		mov	dword [BASE_BORDER_LEFT], ebx
			mov	dword [BASE_BORDER_RIGHT], ebp
			pop	dword ebx
			ret

write_register_17:
			mov	byte  [BASE_REGISTERS + 017h], al
			xor	byte  al, NOT8
			mov	byte  [BASE_SPRITE_Y_EXPAND_MASK], al
			ret

write_register_18:
			or	byte  al, 001h
			call	change_log_write
			mov	byte  [BASE_REGISTERS + 018h], al
			jmp	address_recalculate


write_register_19:
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: correct behavior of this register
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;			and	byte  al, 00fh
;			or	byte  al, 070h
;			mov	byte  [BASE_REGISTERS + 019h], al
			xor	byte  al, al
			mov	byte  [BASE_REGISTERS + 019h], al
			call	c64link_vic_irq
			ret

write_register_1a:
			or	byte  al, 0f0h
			mov	byte  [BASE_REGISTERS + 01ah], al
			ret

write_register_1b:
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: write also to change_log ?
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;			call	change_log_write
			mov	byte  [BASE_REGISTERS + 01bh], al
			ret

write_register_1c:
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: write also to change_log ?
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;			call	change_log_write
			mov	byte  [BASE_REGISTERS + 01ch], al
			ret

write_register_1d:
			mov	byte  [BASE_REGISTERS + 01dh], al
			ret

write_register_1e:
			ret

write_register_1f:
			ret

write_color:
			or	byte  al, 0f0h
			call	change_log_write
			mov	byte  [BASE_REGISTERS + ebp], al
			ret

write_sprite_mcm:
			or	byte  al, 0f0h
			call	change_log_write
			mov	byte  [BASE_REGISTERS + ebp], al
			ret

write_sprite_color:
			or	byte  al, 0f0h
			call	change_log_write
			mov	byte  [BASE_REGISTERS + ebp], al
			ret





;****************************************************************************
;****************************************************************************
;*
;* PART 5: Bus Cycle Functions
;*
;****************************************************************************
;****************************************************************************





;****************************************************************************
;* BUS_CYCLE_VIDEO_READ_BAD_LINE ********************************************
;****************************************************************************
;* eax=>  BASE_STATE
;* ebx=>  BASE_VIDEO_COUNTER
;* ebp=>  BASE_FRAME_OFFSET + BASE_VIDEO_CACHE_OFFSET
;* <=eax  BASE_STATE
;* <=ebx  BASE_VIDEO_COUNTER
;* <=ebp  BASE_FRAME_OFFSET + BASE_VIDEO_CACHE_OFFSET
;****************************************************************************
%macro BUS_CYCLE_VIDEO_READ_BAD_LINE 0
			mov	byte  cl, [C64MEMORY_COLOR_RAM + ebx]
			or	dword ebx, [BASE_VIDEO_ADDRESS]
			mov	byte  [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], cl
			test	dword eax, STATE_VIDEO_ADDRESS_IN_RAM
			mov	byte  dl, [C64MEMORY_RAM + ebx]
			jnz	%%video_address_in_ram
			and	dword ebx, 00fffh
			mov	byte  dl, [C64MEMORY_CHARACTER_ROM + ebx]
%%video_address_in_ram:	mov	dword ebx, [BASE_VIDEO_COUNTER]
			mov	byte  [BASE_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
%endmacro



;****************************************************************************
;* BUS_CYCLE_VIDEO_READ *****************************************************
;****************************************************************************
;* eax=>  BASE_STATE
;* ebx=>  BASE_VIDEO_COUNTER
;* ecx=>  BASE_FRAME_OFFSET_LAST + BASE_VIDEO_CACHE_OFFSET
;* ebp=>  BASE_FRAME_OFFSET + BASE_VIDEO_CACHE_OFFSET
;* <=eax  BASE_STATE
;* <=ebx  BASE_VIDEO_COUNTER
;* <=ebp  BASE_FRAME_OFFSET + BASE_VIDEO_CACHE_OFFSET
;****************************************************************************
%macro BUS_CYCLE_VIDEO_READ 0
			mov	byte  dl, [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ecx]
			mov	byte  cl, [BASE_FRAME + VICLINE_VIDEO_CACHE + ecx]
			mov	byte  [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], dl
			mov	byte  [BASE_FRAME + VICLINE_VIDEO_CACHE + ebp], cl
%endmacro



;****************************************************************************
;* BUS_CYCLE_DATA_READ ******************************************************
;****************************************************************************
;* eax=>  BASE_STATE
;* ebx=>  BASE_VIDEO_COUNTER
;* ebp=>  BASE_FRAME_OFFSET + BASE_VIDEO_CACHE_OFFSET
;* <=eax  BASE_STATE
;* <=edx  BASE_VIDEO_CACHE_OFFSET + 1
;* <=ebp  BASE_FRAME_OFFSET + BASE_VIDEO_CACHE_OFFSET
;****************************************************************************
%macro BUS_CYCLE_DATA_READ 0
			test	byte  [BASE_REGISTERS + 011h], 020h
			jnz	%%bitmap
			xor	dword ebx, ebx
			mov	byte  bl, [BASE_FRAME + VICLINE_VIDEO_CACHE + ebp]
%%bitmap:		mov	dword ecx, [BASE_VIDEO_COUNTER]
			shl	dword ebx, 3
			inc	dword ecx
			or	dword ebx, [BASE_ROW_COUNTER]
			mov	dword [BASE_VIDEO_COUNTER], ecx
			or	dword ebx, [BASE_DATA_ADDRESS]
			mov	dword edx, [BASE_VIDEO_CACHE_OFFSET]
			and	byte  bh, [BASE_ECM_ADDRESS_MASK]
			inc	dword edx
			test	dword ebx, 06000h
			mov	byte  cl, [C64MEMORY_RAM + ebx]
			jnz	%%data_address_in_ram
			test	dword ebx, 01000h
			jz	%%data_address_in_ram
			and	dword ebx, 00fffh
			mov	byte  cl, [C64MEMORY_CHARACTER_ROM + ebx]
%%data_address_in_ram:	mov	byte  [BASE_FRAME + VICLINE_DATA_CACHE + ebp], cl
%endmacro



;****************************************************************************
;* BUS_CYCLE_IDLE_READ ******************************************************
;****************************************************************************
;* eax=>  BASE_STATE
;* ebp=>  BASE_FRAME_OFFSET + BASE_VIDEO_CACHE_OFFSET
;* <=eax  BASE_STATE
;* <=edx  BASE_VIDEO_CACHE_OFFSET + 1
;* <=ebp  BASE_FRAME_OFFSET + BASE_VIDEO_CACHE_OFFSET
;****************************************************************************
%macro BUS_CYCLE_IDLE_READ 0
			mov	dword ebx, [HIGH_BITS]
			mov	dword edx, [BASE_VIDEO_CACHE_OFFSET]
			or	dword ebx, 03fffh
			inc	dword edx
			and	byte  bh, [BASE_ECM_ADDRESS_MASK]
			mov	byte  cl, [C64MEMORY_RAM + ebx]
			xor	byte  bl, bl
			mov	byte  [BASE_FRAME + VICLINE_DATA_CACHE + ebp], cl
			mov	byte  [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], bl
			mov	byte  [BASE_FRAME + VICLINE_VIDEO_CACHE + ebp], bl
%endmacro



;****************************************************************************
;* BUS_CYCLE_SPRITE_READ ****************************************************
;****************************************************************************
%macro BUS_CYCLE_SPRITE_READ 0
			mov	dword ebp, [BASE_SPRITE_CACHE_OFFSET]
			xor	dword ecx, ecx
			mov	dword ebx, ebp
			shl	dword ebp, 2
			mov	byte  al, [BASE_SPRITE_DMA_MASK]
			add	dword ebp, [BASE_FRAME_OFFSET]
			shr	byte  al, 1
			mov	byte  [BASE_SPRITE_DMA_MASK], al
			jnc	%%sprite_off
			call	bus_cycle_sprite_read
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;QUICK HACK: only for temporary testing
;			mov	dword edx, [BASE_FRAME_OFFSET]
;			lea	dword edx, [edx + 4 * ebx]
;			mov	dword [BASE_FRAME + VICLINE_DATA_CACHE + edx], ecx
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
%%sprite_off:		inc	dword ebx
			mov	dword [BASE_FRAME + VICLINE_SPRITE_CACHE + ebp], ecx
			mov	dword [BASE_SPRITE_CACHE_OFFSET], ebx
%endmacro



;****************************************************************************
;* bus_cycle_sprite_read ****************************************************
;****************************************************************************
section .text
bus_cycle_sprite_read:
			mov	byte  al, [BASE_REGISTERS + 018h]
			or	dword ebx, 003f8h
			shl	dword eax, 6
			or	dword ebx, [HIGH_BITS]
			and	dword eax, 03c00h
			xor	dword edx, edx
			or	dword eax, ebx
			mov	byte  dl, [C64MEMORY_RAM + eax]
			test	dword eax, 06000h
			jnz	.no_character_rom_1
			test	dword eax, 01000h
			jz	.no_character_rom_1
			and	dword eax, 00fffh
			mov	byte  dl, [C64MEMORY_CHARACTER_ROM + eax]
.no_character_rom_1:	mov	dword ebx, [BASE_SPRITE_CACHE_OFFSET]
			shl	dword edx, 6
			mov	dword eax, [HIGH_BITS]
			or	byte  dl, [BASE_SPRITE_COUNTERS + ebx]
			xor	dword ecx, ecx
			or	dword eax, edx
			test	dword eax, 06000h
			jnz	.no_character_rom_2
			test	dword eax, 01000h
			jz	.no_character_rom_2
			and	dword eax, 00fffh
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: i might get an overflow if i address like this, because i
;      have to test if SPRITE_COUNTER == 63, with some nasty raster
;      manipulation this condition can be disabled ==> i cross the 64 byte
;      boundary
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			mov	byte  cl, [C64MEMORY_CHARACTER_ROM + eax + 2]
			shl	dword ecx, 16
			mov	byte  ch, [C64MEMORY_CHARACTER_ROM + eax + 1]
			mov	byte  cl, [C64MEMORY_CHARACTER_ROM + eax]
			ret
.no_character_rom_2:	mov	byte  cl, [C64MEMORY_RAM + eax + 2]
			shl	dword ecx, 16
			mov	byte  ch, [C64MEMORY_RAM + eax + 1]
			mov	byte  cl, [C64MEMORY_RAM + eax]
			ret



;****************************************************************************
;* BUS_CYCLE_CHECK_BORDER_LEFT **********************************************
;****************************************************************************
;* eax=>  BASE_STATE
;* ecx=>  line cycle
;* <=eax  BASE_STATE
;* <=ecx  line cycle
;****************************************************************************
%macro BUS_CYCLE_CHECK_BORDER_LEFT 0
			mov	dword edx, [BASE_LINE_COUNTER]
			cmp	dword ecx, [BASE_BORDER_LEFT]
			jne	%%border_left
			cmp	dword edx, [BASE_BORDER_BUTTOM]
			jne	%%border_buttom
			or	dword eax, STATE_BORDER_VERTICAL
%%border_buttom:	cmp	dword edx, [BASE_BORDER_TOP]
			jne	%%border_top
			test	dword eax, STATE_DISPLAY_DISABLE
			jnz	%%border_top
			and	dword eax, (NOT32 - STATE_BORDER_VERTICAL)
%%border_top:		test	dword eax, STATE_BORDER_VERTICAL
			jnz	%%border_left
			and	dword eax, (NOT32 - STATE_BORDER_MAIN)
%%border_left:
%endmacro



;****************************************************************************
;* BUS_CYCLE_CHECK_BORDER_RIGHT *********************************************
;****************************************************************************
;* eax=>  BASE_STATE
;* ecx=>  line cycle + 1
;* <=eax  BASE_STATE
;* <=ecx  line cycle + 1
;****************************************************************************
%macro BUS_CYCLE_CHECK_BORDER_RIGHT 0
			cmp	dword ecx, [BASE_BORDER_RIGHT]
			jne	%%border_right
			or	dword eax, STATE_BORDER_MAIN
%%border_right:
%endmacro



;****************************************************************************
;* BUS_CYCLE_SPRITE_COUNTER_ADD *********************************************
;****************************************************************************
%macro BUS_CYCLE_SPRITE_COUNTER_ADD 1
%ifnidn %1, 1
%ifnidn %1, 2
%error "BUS_CYCLE_SPRITE_COUNTER_ADD: only 1 or 2 allowed!"
%endif
%endif
%ifidn %1, 1
			xor	byte  ch, ch
%endif
			mov	byte  cl, [BASE_SPRITE_Y_EXPAND_MASK]
			xor	dword ebx, ebx
%%loop:			shr	byte  cl, 1
			setc	byte  al
%ifidn %1, 2
			shl	byte  al, 1
%endif
			add	byte  al, [BASE_SPRITE_COUNTERS + ebx]
%ifidn %1, 1
			cmp	byte  al, 03fh
			setne	byte  ah
			or	byte  ch, ah
			ror	byte  ch, 1
%endif
			and	byte  al, 03fh
			mov	byte  [BASE_SPRITE_COUNTERS + ebx], al
			inc	dword ebx
			cmp	byte  bl, 8
			jb	%%loop
%ifidn %1, 1
			mov	byte  al, [BASE_SPRITE_DMA_MASK_BASE]
			and	byte  al, ch
			cmp	byte  al, [BASE_SPRITE_DMA_MASK_BASE]
			je	%%skip_calculation
			call	bus_cycle_calculate_sprite_dma.cycles
%%skip_calculation:
%endif
%endmacro



;****************************************************************************
;* BUS_CYCLE_CHECK_BAD_LINE *************************************************
;****************************************************************************
%macro BUS_CYCLE_CHECK_BAD_LINE 1
%ifnidn %1, [BASE_STATE]
%ifnidn %1, eax
%error "BUS_CYCLE_CHECK_BAD_LINE: only [BASE_STATE] or eax allowed!"
%endif
%endif
%ifnidn %1, eax
			mov	dword eax, [BASE_STATE]
%endif
			test	dword eax, STATE_BAD_LINE
			jnz	%%check_access
			mov	byte  cl, 4
			or	dword eax, (STATE_BAD_LINE | STATE_DISPLAY_MODE)
			mov	byte  [BASE_DMA_DELAY_COUNTER], cl
			call	cpu65xx_signal_set_dma
%%check_access:		cmp	byte  [BASE_DMA_DELAY_COUNTER], 0
			je	%%end
			dec	byte  [BASE_DMA_DELAY_COUNTER]
			jnz	%%end
			or	dword eax, STATE_ACCESS_GRANTED
%%end:
%ifnidn %1, eax
			mov	dword [BASE_STATE], eax
%endif
%endmacro



;****************************************************************************
;* BUS_CYCLE_CHECK_SPRITE_DMA ***********************************************
;****************************************************************************
%macro BUS_CYCLE_CHECK_SPRITE_DMA 1
%ifnidn %1, jmp
%ifnidn %1, call
%error "BUS_CYCLE_CHECK_SPRITE_DMA: only jmp or call allowed!"
%endif
%endif
			mov	dword eax, cpu65xx_signal_clear_dma
			shr	dword [BASE_SPRITE_DMA_CYCLES], 1
			jnc	%%dma_off
			mov	dword eax, cpu65xx_signal_set_dma
%%dma_off:		%1	dword eax
%endmacro



;****************************************************************************
;* BUS_CYCLE_CALCULATE_SPRITE_DMA1 ******************************************
;****************************************************************************
%macro BUS_CYCLE_CALCULATE_SPRITE_DMA1 0
			mov	byte  al, [BASE_SPRITE_DMA_MASK_BASE]
			mov	byte  bl, [BASE_LINE_COUNTER]
			cmp	byte  al, 0ffh
			je	%%skip_calculation
			call	bus_cycle_calculate_sprite_dma
%%skip_calculation:	
%endmacro



;****************************************************************************
;* BUS_CYCLE_CALCULATE_SPRITE_DMA2 ******************************************
;****************************************************************************
%macro BUS_CYCLE_CALCULATE_SPRITE_DMA2 0
			mov	dword ebp, [BASE_SPRITE_DMA_CYCLES_BASE]
			mov	byte  al, [BASE_SPRITE_DMA_MASK_BASE]
			mov	byte  bl, [BASE_LINE_COUNTER]
			cmp	byte  al, 0ffh
			je	%%skip_calculation
			call	bus_cycle_calculate_sprite_dma
%%skip_calculation:	xor	dword ebx, ebx
			mov	byte  [BASE_SPRITE_DMA_MASK], al
			mov	dword [BASE_SPRITE_CACHE_OFFSET], ebx
			mov	dword [BASE_SPRITE_DMA_CYCLES], ebp
%endmacro



;****************************************************************************
;* bus_cycle_calculate_sprite_dma *******************************************
;****************************************************************************
section .text
bus_cycle_calculate_sprite_dma:
			;---------------------------------------------
			;if sprite position y == low 8 bit from 
			;BASE_LINE_COUNTER and the sprite enabled then
			;switch DMA on
			;---------------------------------------------

			cmp	byte  bl, [BASE_REGISTERS + 00fh]
			sete	byte  cl
			cmp	byte  bl, [BASE_REGISTERS + 00dh]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			cmp	byte  bl, [BASE_REGISTERS + 00bh]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			cmp	byte  bl, [BASE_REGISTERS + 009h]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			cmp	byte  bl, [BASE_REGISTERS + 007h]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			cmp	byte  bl, [BASE_REGISTERS + 005h]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			cmp	byte  bl, [BASE_REGISTERS + 003h]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			cmp	byte  bl, [BASE_REGISTERS + 001h]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			and	byte  cl, [BASE_REGISTERS + 015h]
			or	byte  al, cl
			cmp	byte  al, [BASE_SPRITE_DMA_MASK_BASE]
			je	.end

			;------------------------------------------------
			;clear BASE_SPRITE_COUNTER only for those sprites
			;with BASE_LINE_COUNTER == sprite position y
			;------------------------------------------------

			xor	dword ebx, ebx
.loop:			shr	byte  cl, 1
			jnc	.no_clear
			mov	byte  [BASE_SPRITE_COUNTERS + ebx], bh
.no_clear:		inc	dword ebx
			cmp	byte  bl, 8
			jb	.loop

			;-----------------------------------
			;mark the cycles which block the cpu
			;-----------------------------------

.cycles:		mov	byte  [BASE_SPRITE_DMA_MASK_BASE], al
			xor	dword ebx, ebx
			xor	dword ebp, ebp
			mov	byte  bl, 01fh
			shr	byte  al, 1
			jnc	.sprite0_dma_off
			or	dword ebp, ebx
.sprite0_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite1_dma_off
			or	dword ebp, ebx
.sprite1_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite2_dma_off
			or	dword ebp, ebx
.sprite2_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite3_dma_off
			or	dword ebp, ebx
.sprite3_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite4_dma_off
			or	dword ebp, ebx
.sprite4_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite5_dma_off
			or	dword ebp, ebx
.sprite5_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite6_dma_off
			or	dword ebp, ebx
.sprite6_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite7_dma_off
			or	dword ebp, ebx
.sprite7_dma_off:	mov	byte  al, [BASE_SPRITE_DMA_MASK_BASE]
			mov	dword [BASE_SPRITE_DMA_CYCLES_BASE], ebp
.end:			ret



;****************************************************************************
;* BUS_CYCLE_EXTRA_VIDEO_BYTE ***********************************************
;****************************************************************************
;* eax=>  BASE_STATE
;* <=eax  BASE_STATE
;****************************************************************************
%macro BUS_CYCLE_EXTRA_VIDEO_BYTE 0
			mov	dword ebx, [BASE_FRAME_OFFSET]
			xor	dword ecx, ecx
			mov	dword ebp, [BASE_FRAME_OFFSET_UNUSED]
			mov	byte  dl, [BASE_EXTRA_VIDEO_BYTE]
			test	dword eax, STATE_BORDER_MAIN
			jnz	.border
			mov	byte  dl, [BASE_FRAME + VICLINE_VIDEO_CACHE + 40 + ebx]
			mov	byte  [BASE_EXTRA_VIDEO_BYTE], dl
.border			mov	byte  [BASE_FRAME + VICLINE_DATA_CACHE + ebp], cl
			mov	byte  [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], cl
			mov	byte  [BASE_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
%endmacro



;****************************************************************************
;* bus_cycle_switch *********************************************************
;****************************************************************************
section .text
bus_cycle_switch:
			mov	dword eax, [BASE_EXECUTE_CYCLE_SWITCH]
			mov	dword [BASE_EXECUTE_CYCLE], eax
			call	dword eax
			mov	dword eax, [BASE_EXECUTE_CYCLE]
			mov	dword ebx, eax
			call	get_cycle_function
			cmp	dword eax, ebx
			je	.no_switch
			mov	dword [BASE_EXECUTE_CYCLE], eax
			BUS_CYCLE_CHECK_BAD_LINE  [BASE_STATE]
.no_switch:		ret



;****************************************************************************
;* bus_cycle_0_new_frame ****************************************************
;****************************************************************************
section .text
bus_cycle_0_new_frame:
%ifdef VIC6569_DISABLE_LINEWISE_DECODING
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: DECODE_LINES is a pointer!
			xor	dword eax, eax
			mov	dword [DECODE_LINES], eax
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			call	decode_screen
%endif
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: DECODE_LINES is a pointer!
			mov	dword eax, [DECODE_LINES]
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			mov	dword ebx, [DECODE_LINES_LIST]
			xor	dword ecx, ecx
			mov	dword [ebx + 4 * eax], ecx
			call	core_new_frame
			mov	byte  al, [BASE_REGISTERS + 011h]
			mov	dword ebx, [BASE_STATE]
			xor	dword ecx, ecx
			and	dword ebx, (NOT32 - STATE_DISPLAY_DISABLE)
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: DECODE_LINES is a pointer!
			mov	dword [DECODE_LINES], ecx
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			mov	dword [BASE_VIDEO_COUNTER], ecx
			test	byte  al, 010h
			jnz	.display_enabled
			or	dword ebx, STATE_DISPLAY_DISABLE
.display_enabled:	mov	byte  [BASE_REGISTERS + 012h], cl
			and	byte  al, 07fh
			mov	dword [BASE_STATE], ebx
			mov	byte  [BASE_REGISTERS + 011h], al
			mov	dword ebx, bus_cycle_1
			cmp	dword ecx, [BASE_LINE_LATCH]
			jne	.line_latch_differs
			mov	dword ebx, bus_cycle_1_new_frame
.line_latch_differs:	mov	dword [BASE_EXECUTE_CYCLE], ebx
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_1_new_frame ****************************************************
;****************************************************************************
section .text
bus_cycle_1_new_frame:
			mov	byte  bl, [BASE_REGISTERS + 019h]
			mov	byte  al, [BASE_REGISTERS + 01ah]
			or	byte  bl, 001h
			test	byte  al, 001h
			jz	.no_irq
			or	byte  bl, 080h
			mov	byte  al, 1
			call	c64link_vic_irq
.no_irq:		mov	dword eax, bus_cycle_2
			mov	byte  [BASE_REGISTERS + 019h], bl
			mov	dword [BASE_EXECUTE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_0 **************************************************************
;****************************************************************************
section .text
bus_cycle_0:
			mov	dword ebx, [BASE_LINE_COUNTER]
			cmp	dword ebx, [BASE_LINE_LATCH]
			jne	.end
			mov	byte  cl, [BASE_REGISTERS + 019h]
			mov	byte  al, [BASE_REGISTERS + 01ah]
			or	byte  cl, 001h
			test	byte  al, 001h
			jz	.no_irq
			or	byte  cl, 080h
			mov	byte  al, 1
			call	c64link_vic_irq
.no_irq:		mov	byte  [BASE_REGISTERS + 019h], cl
.end:			mov	byte  [BASE_REGISTERS + 012h], bl
			mov	byte  al, [BASE_REGISTERS + 011h]
			ror	byte  bh, 1
			and	byte  al, 07fh
			mov	dword ecx, bus_cycle_1
			or	byte  al, bh
			mov	dword [BASE_EXECUTE_CYCLE], ecx
			mov	byte  [BASE_REGISTERS + 011h], al
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_1 **************************************************************
;****************************************************************************
section .text
bus_cycle_1:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_2
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_2 **************************************************************
;****************************************************************************
section .text
bus_cycle_2:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_3
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_3 **************************************************************
;****************************************************************************
section .text
bus_cycle_3:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_4
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_4 **************************************************************
;****************************************************************************
section .text
bus_cycle_4:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_5
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_5 **************************************************************
;****************************************************************************
section .text
bus_cycle_5:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_6
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_6 **************************************************************
;****************************************************************************
section .text
bus_cycle_6:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_7
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_7 **************************************************************
;****************************************************************************
section .text
bus_cycle_7:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_8
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_8 **************************************************************
;****************************************************************************
section .text
bus_cycle_8:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_9
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_9 **************************************************************
;****************************************************************************
section .text
bus_cycle_9:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_10
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_10 *************************************************************
;****************************************************************************
section .text
bus_cycle_10:
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: the bad line behavior might be incorrect, because if i change in the
;      next cycle BASE_REGISTERS + 11h, so that this line isn't a bad line,
;      the bad line condition stays enabled
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			mov	dword eax, [BASE_STATE]
			mov	dword ebx, bus_cycle_11_idle
			test	dword eax, STATE_BAD_LINE_EXPECTED
			jz	.no_bad_line
			mov	dword ebx, bus_cycle_11
.no_bad_line:		mov	dword [BASE_EXECUTE_CYCLE], ebx
			jmp	cpu65xx_signal_clear_dma



;****************************************************************************
;* bus_cycle_11_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_11_idle:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_12_idle
			ret



;****************************************************************************
;* bus_cycle_12_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_12_idle:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_13_idle
			ret



;****************************************************************************
;* bus_cycle_13_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_13_idle:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_14_idle
			ret



;****************************************************************************
;* bus_cycle_14_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_14_idle:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_15_idle
			BUS_CYCLE_SPRITE_COUNTER_ADD  2
			ret



;****************************************************************************
;* bus_cycle_15_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_15_idle:
			mov	dword eax, [BASE_STATE]
			mov	dword ecx, [BASE_VIDEO_CACHE_OFFSET]
			mov	dword ebx, [BASE_VIDEO_COUNTER]
			mov	dword ebp, ecx
			add	dword ecx, [BASE_FRAME_OFFSET_LAST]
			add	dword ebp, [BASE_FRAME_OFFSET]
			test	dword eax, STATE_DISPLAY_MODE
			jz	near  .idle
			BUS_CYCLE_VIDEO_READ
			BUS_CYCLE_DATA_READ
			jmp	.exit
.idle:			BUS_CYCLE_IDLE_READ
.exit:			mov	dword [BASE_VIDEO_CACHE_OFFSET], edx
			mov	dword ecx, 15
			BUS_CYCLE_CHECK_BORDER_LEFT
			mov	dword ebx, bus_cycle_16_idle
			mov	dword [BASE_STATE], eax
			mov	dword [BASE_EXECUTE_CYCLE], ebx
			BUS_CYCLE_SPRITE_COUNTER_ADD  1
			ret



;****************************************************************************
;* bus_cycle_16_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_16_idle:
			mov	dword eax, [BASE_STATE]
			mov	dword ecx, [BASE_VIDEO_CACHE_OFFSET]
			mov	dword ebx, [BASE_VIDEO_COUNTER]
			mov	dword ebp, ecx
			add	dword ecx, [BASE_FRAME_OFFSET_LAST]
			add	dword ebp, [BASE_FRAME_OFFSET]
			test	dword eax, STATE_DISPLAY_MODE
			jz	near  .idle
			BUS_CYCLE_VIDEO_READ
			BUS_CYCLE_DATA_READ
			jmp	.exit
.idle:			BUS_CYCLE_IDLE_READ
.exit:			mov	dword [BASE_VIDEO_CACHE_OFFSET], edx
			mov	dword ecx, 16
			BUS_CYCLE_CHECK_BORDER_LEFT
			mov	dword [BASE_STATE], eax
			mov	dword ebx, bus_cycle_17_idle
			mov	byte  cl, 37
			mov	dword [BASE_EXECUTE_CYCLE], ebx
			mov	byte  [BASE_CYCLE_COUNTER], cl
			ret



;****************************************************************************
;* bus_cycle_17_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_17_idle:
			mov	dword eax, [BASE_STATE]
			mov	dword ecx, [BASE_VIDEO_CACHE_OFFSET]
			mov	dword ebx, [BASE_VIDEO_COUNTER]
			mov	dword ebp, ecx
			add	dword ecx, [BASE_FRAME_OFFSET_LAST]
			add	dword ebp, [BASE_FRAME_OFFSET]
			test	dword eax, STATE_DISPLAY_MODE
			jz	near  .idle
			BUS_CYCLE_VIDEO_READ
			BUS_CYCLE_DATA_READ
			jmp	.exit
.idle:			BUS_CYCLE_IDLE_READ
.exit:			mov	byte  bl, [BASE_CYCLE_COUNTER]
			mov	dword [BASE_VIDEO_CACHE_OFFSET], edx
			dec	byte  bl
			mov	dword [BASE_STATE], eax
			mov	byte  [BASE_CYCLE_COUNTER], bl
			mov	dword edx, bus_cycle_54_idle
			jnz	.end
			mov	dword [BASE_EXECUTE_CYCLE], edx
.end:			ret



;****************************************************************************
;* bus_cycle_54_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_54_idle:
			mov	dword eax, [BASE_STATE]
			mov	dword ecx, [BASE_VIDEO_CACHE_OFFSET]
			mov	dword ebx, [BASE_VIDEO_COUNTER]
			mov	dword ebp, ecx
			add	dword ecx, [BASE_FRAME_OFFSET_LAST]
			add	dword ebp, [BASE_FRAME_OFFSET]
			test	dword eax, STATE_DISPLAY_MODE
			jz	near  .idle
			BUS_CYCLE_VIDEO_READ
			BUS_CYCLE_DATA_READ
			jmp	.exit
.idle:			BUS_CYCLE_IDLE_READ
.exit:			mov	dword [BASE_VIDEO_CACHE_OFFSET], edx
			BUS_CYCLE_EXTRA_VIDEO_BYTE
			mov	dword ebx, bus_cycle_55
			mov	dword ecx, 55
			BUS_CYCLE_CHECK_BORDER_RIGHT
			mov	byte  cl, [BASE_SPRITE_Y_EXPAND_MASK]
			mov	dword [BASE_EXECUTE_CYCLE], ebx
			xor	byte  cl, [BASE_REGISTERS + 017h]
			mov	dword [BASE_STATE], eax
			mov	byte  [BASE_SPRITE_Y_EXPAND_MASK], cl
			BUS_CYCLE_CALCULATE_SPRITE_DMA1
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_11 *************************************************************
;****************************************************************************
section .text
bus_cycle_11:
			BUS_CYCLE_CHECK_BAD_LINE  [BASE_STATE]
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_12
			ret



;****************************************************************************
;* bus_cycle_12 *************************************************************
;****************************************************************************
section .text
bus_cycle_12:
			BUS_CYCLE_CHECK_BAD_LINE  [BASE_STATE]
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_13
			ret



;****************************************************************************
;* bus_cycle_13 *************************************************************
;****************************************************************************
section .text
bus_cycle_13:
			mov	dword eax, [BASE_STATE]
			BUS_CYCLE_CHECK_BAD_LINE  eax
			xor	dword ebx, ebx
			mov	dword ecx, bus_cycle_14
			test	dword eax, STATE_BAD_LINE
			jz	.end
			mov	dword [BASE_ROW_COUNTER], ebx
.end:			mov	dword [BASE_EXECUTE_CYCLE], ecx
			mov	dword [BASE_STATE], eax
			ret



;****************************************************************************
;* bus_cycle_14 *************************************************************
;****************************************************************************
section .text
bus_cycle_14:
			BUS_CYCLE_CHECK_BAD_LINE  [BASE_STATE]
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_15
			BUS_CYCLE_SPRITE_COUNTER_ADD  2
			ret



;****************************************************************************
;* bus_cycle_15 *************************************************************
;****************************************************************************
section .text
bus_cycle_15:
			mov	dword eax, [BASE_STATE]
			mov	dword ebp, [BASE_VIDEO_CACHE_OFFSET]
			mov	dword ebx, [BASE_VIDEO_COUNTER]
			add	dword ebp, [BASE_FRAME_OFFSET]
			test	dword eax, STATE_ACCESS_GRANTED
			jz	.read_rubbish
			BUS_CYCLE_VIDEO_READ_BAD_LINE
			jmp	.data
.read_rubbish:		mov	byte  dl, 0ffh
			mov	byte  [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], dl
			mov	byte  [BASE_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
.data:			BUS_CYCLE_CHECK_BAD_LINE  eax
			BUS_CYCLE_DATA_READ
			mov	dword [BASE_VIDEO_CACHE_OFFSET], edx
			mov	dword ecx, 15
			BUS_CYCLE_CHECK_BORDER_LEFT
			mov	dword ebx, bus_cycle_16
			mov	dword [BASE_STATE], eax
			mov	dword [BASE_EXECUTE_CYCLE], ebx
			BUS_CYCLE_SPRITE_COUNTER_ADD  1
			ret



;****************************************************************************
;* bus_cycle_16 *************************************************************
;****************************************************************************
section .text
bus_cycle_16:
			mov	dword eax, [BASE_STATE]
			mov	dword ebp, [BASE_VIDEO_CACHE_OFFSET]
			mov	dword ebx, [BASE_VIDEO_COUNTER]
			add	dword ebp, [BASE_FRAME_OFFSET]
			test	dword eax, STATE_ACCESS_GRANTED
			jz	.read_rubbish
			BUS_CYCLE_VIDEO_READ_BAD_LINE
			jmp	.data
.read_rubbish:		mov	byte  dl, 0ffh
			mov	byte  [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], dl
			mov	byte  [BASE_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
.data:			BUS_CYCLE_CHECK_BAD_LINE  eax
			BUS_CYCLE_DATA_READ
			mov	dword [BASE_VIDEO_CACHE_OFFSET], edx
			mov	dword ecx, 16
			BUS_CYCLE_CHECK_BORDER_LEFT
			mov	dword [BASE_STATE], eax
			mov	dword ebx, bus_cycle_17
			mov	byte  cl, 37
			mov	dword [BASE_EXECUTE_CYCLE], ebx
			mov	byte  [BASE_CYCLE_COUNTER], cl
			ret



;****************************************************************************
;* bus_cycle_17 *************************************************************
;****************************************************************************
section .text
bus_cycle_17:
			mov	dword eax, [BASE_STATE]
			mov	dword ebp, [BASE_VIDEO_CACHE_OFFSET]
			mov	dword ebx, [BASE_VIDEO_COUNTER]
			add	dword ebp, [BASE_FRAME_OFFSET]
			test	dword eax, STATE_ACCESS_GRANTED
			jz	.read_rubbish
			BUS_CYCLE_VIDEO_READ_BAD_LINE
			jmp	.data
.read_rubbish:		mov	byte  dl, 0ffh
			mov	byte  [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], dl
			mov	byte  [BASE_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
.data:			BUS_CYCLE_CHECK_BAD_LINE  eax
			BUS_CYCLE_DATA_READ
			mov	byte  bl, [BASE_CYCLE_COUNTER]
			mov	dword [BASE_VIDEO_CACHE_OFFSET], edx
			dec	byte  bl
			mov	dword [BASE_STATE], eax
			mov	byte  [BASE_CYCLE_COUNTER], bl
			mov	dword edx, bus_cycle_54
			jnz	.end
			mov	dword [BASE_EXECUTE_CYCLE], edx
.end:			ret



;****************************************************************************
;* bus_cycle_54 *************************************************************
;****************************************************************************
section .text
bus_cycle_54:
			mov	dword eax, [BASE_STATE]
			mov	dword ebp, [BASE_VIDEO_CACHE_OFFSET]
			mov	dword ebx, [BASE_VIDEO_COUNTER]
			add	dword ebp, [BASE_FRAME_OFFSET]
			test	dword eax, STATE_ACCESS_GRANTED
			jz	.read_rubbish
			BUS_CYCLE_VIDEO_READ_BAD_LINE
			jmp	.data
.read_rubbish:		mov	byte  dl, 0ffh
			mov	byte  [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], dl
			mov	byte  [BASE_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
.data:			BUS_CYCLE_DATA_READ
			mov	dword [BASE_VIDEO_CACHE_OFFSET], edx
			BUS_CYCLE_EXTRA_VIDEO_BYTE
			mov	dword ebx, bus_cycle_55
			mov	dword ecx, 55
			and	dword eax, (NOT32 - STATE_BAD_LINE - STATE_ACCESS_GRANTED)
			BUS_CYCLE_CHECK_BORDER_RIGHT
			mov	byte  cl, [BASE_SPRITE_Y_EXPAND_MASK]
			mov	dword [BASE_EXECUTE_CYCLE], ebx
			xor	byte  cl, [BASE_REGISTERS + 017h]
			mov	dword [BASE_STATE], eax
			mov	byte  [BASE_SPRITE_Y_EXPAND_MASK], cl
			BUS_CYCLE_CALCULATE_SPRITE_DMA1
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_55 *************************************************************
;****************************************************************************
section .text
bus_cycle_55:
			mov	dword eax, [BASE_STATE]
			mov	dword ecx, 56
			mov	dword ebx, bus_cycle_56
			BUS_CYCLE_CHECK_BORDER_RIGHT
			mov	dword [BASE_EXECUTE_CYCLE], ebx
			mov	dword [BASE_STATE], eax
			BUS_CYCLE_CALCULATE_SPRITE_DMA2
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_56 *************************************************************
;****************************************************************************
section .text
bus_cycle_56:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_57
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_57 *************************************************************
;****************************************************************************
section .text
bus_cycle_57:
			mov	dword eax, [BASE_STATE]
			mov	dword ebx, [BASE_ROW_COUNTER]
			mov	dword ecx, [BASE_VIDEO_COUNTER]
			mov	dword edx, bus_cycle_58
			cmp	byte  bl, 7
			jb	.no_wrap
			xor	dword ebx, ebx
			and	dword eax, (NOT32 - STATE_DISPLAY_MODE)
			mov	dword [BASE_ROW_COUNTER], ebx
			mov	dword [BASE_STATE], eax
			jmp	.end
.no_wrap:		test	dword eax, STATE_DISPLAY_MODE
			jz	.end
			sub	dword ecx, byte 40
			inc	dword ebx
			and	dword ecx, 003ffh
			mov	dword [BASE_ROW_COUNTER], ebx
			mov	dword [BASE_VIDEO_COUNTER], ecx
.end:			mov	dword [BASE_EXECUTE_CYCLE], edx
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_58 *************************************************************
;****************************************************************************
section .text
bus_cycle_58:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_59
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_59 *************************************************************
;****************************************************************************
section .text
bus_cycle_59:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_60
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_60 *************************************************************
;****************************************************************************
section .text
bus_cycle_60:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_61
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_61 *************************************************************
;****************************************************************************
section .text
bus_cycle_61:
			mov	dword [BASE_EXECUTE_CYCLE], bus_cycle_62
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_62 *************************************************************
;****************************************************************************
section .text
bus_cycle_62:
			;-------------------------------
			;clear unused CHANGE_LOG entries
			;-------------------------------

			cld
			mov	dword ecx, CHANGE_LOG_SIZE
			mov	dword edx, [BASE_CHANGE_LOG_OFFSET]
			sub	dword ecx, edx
			jz	.change_log_full
%ifdef VIC6569_ASSERTION
%ifdef VIC6569_ASSERTION_CHANGE_LOG_OVERFLOW
			jnc	.no_underflow
			mov	dword eax, [MODULID]
			xor	dword ebx, ebx
			mov	dword ecx, __LINE__
			jmp	core_assertion
.no_underflow:
%endif
%endif
			shl	dword edx, 2	;assumes dword size of CHANGE_LOG entries
			mov	dword ebx, [BASE_FRAME_OFFSET]
			add	dword ebx, edx
			xor	dword eax, eax
			lea	dword edi, [BASE_FRAME + VICLINE_CHANGE_LOG + ebx]
			rep stosd
.change_log_full:
			;----------------------------------------------
			;copy BASE_SPRITE_DMA_MASK_LAST, BASE_STATE and
			;BASE_LINE_COUNTER to the current line
			;----------------------------------------------

			mov	dword edx, [BASE_FRAME_OFFSET]
			mov	byte  al, [BASE_SPRITE_DMA_MASK_LAST]
			lea	dword edx, [BASE_FRAME + edx]
			mov	dword ebx, [BASE_STATE]
			mov	dword ecx, [BASE_LINE_COUNTER]
			mov	byte  [edx + VICLINE_SPRITE_DMA_MASK_LAST], al
			mov	dword [edx + VICLINE_STATE], ebx
			mov	dword [edx + VICLINE_LINE_COUNTER], ecx

%ifndef VIC6569_DISABLE_SELECTIVE_DECODING
			;--------------------------------------------------
			;compare data from BASE_FRAME_OFFSET with data from
			;the frame before stored at BASE_FRAME_OFFSET_NEXT
			;--------------------------------------------------

			mov	dword eax, [BASE_FRAME_OFFSET]
			mov	dword ebx, [BASE_FRAME_OFFSET_NEXT]
			mov	dword ecx, (VICLINE_SIZE / 4)
			push	dword esi
			lea	dword edx, [BASE_FRAME + eax]
			lea	dword ebp, [BASE_FRAME + ebx]
			mov	dword esi, edx
			mov	dword edi, ebp
			repe cmpsd
			pop	dword esi
			test	dword ecx, ecx
			mov	dword ebx, [BASE_LINE_COUNTER]
			setnz	byte  cl
			mov	byte  [DECODE_LINES_MARKED + ebx], cl
%endif

			;-------------------------------------
			;copy BASE_REGISTERS for the next line
			;-------------------------------------

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: copy only selected VIC registers to next line and not all like now
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			mov	dword eax, [BASE_FRAME_OFFSET_UNUSED]
			mov	dword ecx, (REGISTERS_SIZE / 4)
			push	dword esi
			lea	dword ebx, [BASE_REGISTERS]
			lea	dword edx, [BASE_FRAME + VICLINE_REGISTERS + eax]
			mov	dword esi, ebx
			mov	dword edi, edx
			rep movsd
			pop	dword esi

			;---------------
			;decode the line
			;---------------

%ifndef VIC6569_DISABLE_LINEWISE_DECODING
			mov	dword eax, [BASE_FRAME_OFFSET_LAST]
			mov	dword ebx, [BASE_FRAME_OFFSET]
			mov	dword [DECODE_FRAME_OFFSET_LAST], eax
			mov	dword [DECODE_FRAME_OFFSET], ebx
			call	decode_line
%endif

			;----------------------------------------------------
			;increment BASE_FRAME_OFFSET_LAST, BASE_FRAME_OFFSET,
			;BASE_FRAME_OFFSET_UNUSED and BASE_FRAME_OFFSET_NEXT,
			;reset BASE_VIDEO_CACHE_OFFSET and
			;BASE_CHANGE_LOG_OFFSET
			;----------------------------------------------------

			mov	dword eax, [BASE_FRAME_OFFSET]
			mov	dword ebx, [BASE_FRAME_OFFSET_UNUSED]
			mov	dword ecx, [BASE_FRAME_OFFSET_NEXT]
			xor	dword edx, edx
			mov	dword [BASE_FRAME_OFFSET_LAST], eax
			mov	dword [BASE_CHANGE_LOG_OFFSET], edx
			mov	dword [BASE_FRAME_OFFSET], ebx
			mov	dword [BASE_FRAME_OFFSET_UNUSED], ecx
			inc	dword edx
			add	dword ecx, VICLINE_SIZE
			mov	dword [BASE_VIDEO_CACHE_OFFSET], edx
			cmp	dword ecx, ((LINES_PER_FRAME + 2) * VICLINE_SIZE)
			jb	.no_frame_wrap
			xor	dword ecx, ecx
.no_frame_wrap:		mov	dword [BASE_FRAME_OFFSET_NEXT], ecx

			;------------------------------
			;update the BASE_LINE_TIMESTAMP
			;------------------------------

			GET_CYCLES
			mov	dword [BASE_LINE_TIMESTAMP], eax
			mov	dword [BASE_LINE_TIMESTAMP + 4], edx
%ifdef VIC6569_LOG_HACK
			cmp	dword eax, 001078000h
			jb	.no_log
			or	dword [BASE_STATE], 010000000h
.no_log:
%endif ;VIC6569_LOG_HACK

			;---------------------------------------------------
			;check border conditions increment BASE_LINE_COUNTER
			;and DECODE_SCREEN_START
			;---------------------------------------------------

			mov	dword ebx, [BASE_LINE_COUNTER]
			mov	dword eax, [BASE_STATE]
			cmp	dword ebx, [BASE_BORDER_BUTTOM]
			jne	.border_buttom
			or	dword eax, STATE_BORDER_VERTICAL
.border_buttom:		cmp	dword ebx, [BASE_BORDER_TOP]
			jne	.border_top
			test	dword eax, STATE_DISPLAY_DISABLE
			jnz	.border_top
			and	dword eax, (NOT32 - STATE_BORDER_VERTICAL)
.border_top:		mov	dword ecx, bus_cycle_0
			mov	dword [BASE_STATE], eax
			mov	dword edx, [DECODE_SCREEN]
			inc	dword ebx
			add	dword edx, [DECODE_SCREEN_LINE_LENGTH]
			cmp	dword ebx, LINES_PER_FRAME
			jb	.no_line_wrap
			mov	dword edx, [DECODE_SCREEN_START]
			xor	dword ebx, ebx
			mov	dword ecx, bus_cycle_0_new_frame
.no_line_wrap:		mov	dword [DECODE_SCREEN], edx
			mov	dword [BASE_LINE_COUNTER], ebx
			mov	dword [BASE_EXECUTE_CYCLE], ecx

			;-------------------------------------------------
			;copy the SPRITE_DMA_MASK, this must be done after
			;decoding
			;-------------------------------------------------

			mov	byte  al, [BASE_SPRITE_DMA_MASK_BASE]
			mov	byte  [BASE_SPRITE_DMA_MASK_LAST], al

			;-------------------------------------
			;decide if the next line is a bad line
			;-------------------------------------

			call	check_bad_line
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



%ifdef VIC6569_LOG_HACK
;****************************************************************************
;* vic6569_log **************************************************************
;****************************************************************************
section .text
vic6569_log:
			mov	dword eax, [BASE_EXECUTE_CYCLE]
			xor	dword ecx, ecx
			dec	dword ecx
.loop:			inc	dword ecx
			mov	dword ebx, [.ap__cycle_functions + 8 * ecx]
			test	dword ebx, ebx
			jz	.loop_end
			cmp	dword ebx, eax
			jne	.loop
			mov	dword eax, [.ap__cycle_functions + 8 * ecx + 4]
.loop_end:		mov	dword ebx, eax
			GET_CYCLES
			sub	dword eax, [BASE_LINE_TIMESTAMP]
;			sbb	dword edx, [BASE_LINE_TIMESTAMP + 4]
			mov	byte  ah, [BASE_REGISTERS + 01ah]
			mov	dword ecx, [BASE_LINE_COUNTER]
			mov	dword edx, [BASE_LINE_LATCH]
			jmp	core_log

			align	4
.ap__cycle_functions:	dd	bus_cycle_switch, 0ffffh
			dd	bus_cycle_0_new_frame, 00100h
			dd	bus_cycle_1_new_frame, 00101h
			dd	bus_cycle_0, 00000h
			dd	bus_cycle_1, 00001h
			dd	bus_cycle_2, 00002h
			dd	bus_cycle_3, 00003h
			dd	bus_cycle_4, 00004h
			dd	bus_cycle_5, 00005h
			dd	bus_cycle_6, 00006h
			dd	bus_cycle_7, 00007h
			dd	bus_cycle_8, 00008h
			dd	bus_cycle_9, 00009h
			dd	bus_cycle_10, 00010h
			dd	bus_cycle_11, 00011h
			dd	bus_cycle_12, 00012h
			dd	bus_cycle_13, 00013h
			dd	bus_cycle_14, 00014h
			dd	bus_cycle_15, 00015h
			dd	bus_cycle_16, 00016h
			dd	bus_cycle_17, 00017h
			dd	bus_cycle_54, 00054h
			dd	bus_cycle_55, 00055h
			dd	bus_cycle_56, 00056h
			dd	bus_cycle_57, 00057h
			dd	bus_cycle_58, 00058h
			dd	bus_cycle_59, 00059h
			dd	bus_cycle_60, 00060h
			dd	bus_cycle_61, 00061h
			dd	bus_cycle_62, 00062h
			dd	bus_cycle_11_idle, 00211h
			dd	bus_cycle_12_idle, 00212h
			dd	bus_cycle_13_idle, 00213h
			dd	bus_cycle_14_idle, 00214h
			dd	bus_cycle_15_idle, 00215h
			dd	bus_cycle_16_idle, 00216h
			dd	bus_cycle_17_idle, 00217h
			dd	bus_cycle_54_idle, 00254h
			dd	0, 0
%endif ;VIC6569_LOG_HACK





;****************************************************************************
;****************************************************************************
;*
;* PART 6: Decoding Functions
;*
;****************************************************************************
;****************************************************************************





;****************************************************************************
;* decode_screen ************************************************************
;****************************************************************************
section .text
decode_screen:
			mov	dword eax, [DECODE_SCREEN_LINE_LENGTH]
			mov	dword ebx, [BASE_FRAME_OFFSET_NEXT]
			mov	dword ecx, [BASE_FRAME + VICLINE_LINE_COUNTER + ebx]
%ifdef VIC6569_ASSERTION_DECODE_LINE_COUNTER
			cmp	dword ecx, LINES_PER_FRAME
			jb	.line_counter_ok
			mov	dword eax, [MODULID]
			xor	dword ebx, ecx
			mov	dword ecx, __LINE__
			jmp	core_assertion
.line_counter_ok:
%endif
			mul	dword ecx
			add	dword eax, [DECODE_SCREEN_START]
			mov	dword edx, ecx
			mov	dword [DECODE_SCREEN], eax
			mov	dword ecx, LINES_PER_FRAME
			mov	dword eax, [BASE_FRAME_OFFSET_UNUSED]
.next_line:		mov	dword [DECODE_FRAME_OFFSET_LAST], eax
			mov	dword [DECODE_FRAME_OFFSET], ebx
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			call	decode_line
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			mov	dword eax, [DECODE_SCREEN]
			inc	dword edx
			add	dword eax, [DECODE_SCREEN_LINE_LENGTH]
			cmp	dword edx, LINES_PER_FRAME
			jb	.no_line_wrap
			mov	dword eax, [DECODE_SCREEN_START]
			xor	dword edx, edx
.no_line_wrap:		mov	dword [DECODE_SCREEN], eax
			pop	dword eax
			mov	dword eax, ebx
			add	dword ebx, VICLINE_SIZE
			cmp	dword ebx, ((LINES_PER_FRAME + 2) * VICLINE_SIZE)
			jb	.no_frame_wrap
			xor	dword ebx, ebx
.no_frame_wrap:		dec	dword ecx
			jnz	.next_line
			ret



;****************************************************************************
;* decode_line **************************************************************
;****************************************************************************
section .text
decode_line:
			mov	dword edx, [DECODE_FRAME_OFFSET]
			lea	dword edx, [BASE_FRAME + edx]
			mov	dword ebx, [edx + VICLINE_LINE_COUNTER]
			test	byte  [DECODE_LINES_MARKED + ebx], NOT8
			jz	near  .end
			cmp	dword ebx, [DECODE_Y_START]
			jb	near  .end
			cmp	dword ebx, [DECODE_Y_END]
			jae	near  .end
			mov	dword eax, ebx
			mov	dword ebx, [DECODE_LINES_LIST]
			sub	dword eax, [DECODE_Y_START]
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: DECODE_LINES is a pointer
			mov	dword ecx, [DECODE_LINES]
			inc	dword eax
			mov	dword [ebx + 4 * ecx], eax
			inc	dword ecx
			mov	dword [DECODE_LINES], ecx
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			mov	byte  al, [edx + VICLINE_SPRITE_DMA_MASK_LAST]
			mov	dword ebx, [edx + VICLINE_STATE]
			mov	byte  [DECODE_SPRITE_DMA_MASK_LAST], al
			mov	dword [DECODE_STATE], ebx
			mov	dword ecx, (REGISTERS_SIZE / 4)
			push	dword esi
			lea	dword ebx, [edx + VICLINE_REGISTERS]
			lea	dword edx, [DECODE_REGISTERS]
			mov	dword esi, ebx
			mov	dword edi, edx
			cld
			rep movsd
			pop	dword esi
			mov	dword ebx, [DECODE_FRAME_OFFSET]
			xor	dword ecx, ecx
			xor	dword edx, edx
			jmp	.no_change
.loop:			mov	dword eax, [BASE_FRAME + VICLINE_CHANGE_LOG + ebx]
			inc	dword ecx
			or	dword eax, eax
			jz	.no_change
			cmp	byte  al, cl
			jne	.no_change
			shr	dword eax, 8
			add	dword ebx, 4
			mov	byte  dl, ah
			mov	byte  [DECODE_REGISTERS + edx], al
.no_change:		cmp	dword ecx, [DECODE_X_START]
			jb	.loop
			mov	dword eax, [DECODE_STATE]
			test	dword eax, STATE_BORDER_MAIN
			jz	decode_overscan
			test	dword eax, STATE_BORDER_VERTICAL
			jz	decode_window
			jmp	decode_border
.end:			ret



;****************************************************************************
;* decode_overscan **********************************************************
;****************************************************************************
section .text
decode_overscan:
			ret



;****************************************************************************
;* decode_window ************************************************************
;****************************************************************************
section .text
decode_window:
			call	decode_cycle_window_select
.loop:			xor	dword edx, edx
			mov	dword eax, [BASE_FRAME + VICLINE_CHANGE_LOG + ebx]
			mov	byte  dl, [.ab__decode_functions + ecx]
			or	dword eax, eax
			jz	.no_change
			cmp	byte  al, cl
			jne	.no_change
			push	dword ebx
			shr	dword eax, 8
			xor	dword ebx, ebx
			mov	byte  bl, ah
			mov	byte  [DECODE_REGISTERS + ebx], al
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: ap__change_functions ==> decode_cycle_window_select must be called
			cmp	byte  ah, 011h
			je	.select
			cmp	byte  ah, 016h
			jne	.skip_select
.select:		call	decode_cycle_window_select
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
.skip_select:		pop	dword ebx
			add	dword ebx, 4
.no_change:		call	dword [.ap__decode_addresses + 4 * edx]
			inc	dword ecx
			cmp	dword ecx, [DECODE_X_END]
			jb	.loop
			ret

.ab__decode_functions:	times 15	db	0
					db	1
			times 37	db	2
					db	3
					db	4
			times 8		db	0

			align	4
.ap__decode_addresses:	dd	decode_cycle_border
			dd	decode_cycle_window_left
			dd	decode_cycle_window_central
			dd	decode_cycle_window_right1
			dd	decode_cycle_window_right2



;****************************************************************************
;* decode_border ************************************************************
;****************************************************************************
section .text
decode_border:
			mov	byte  dl, [DECODE_REGISTERS + 020h]
			and	dword edx, 00000000fh
			mov	dword edi, [DECODE_SCREEN]
			mov	dword edx, [ad__transform_table + 4 * edx]
.loop:			mov	dword eax, [BASE_FRAME + VICLINE_CHANGE_LOG + ebx]
			or	dword eax, eax
			jz	.no_change
			cmp	byte  al, cl
			jne	.no_change
			shr	dword eax, 8
			add	dword ebx, 4
			cmp	byte  ah, 020h
			jne	.no_change
			and	dword eax, 00000000fh
			mov	dword edx, [ad__transform_table + 4 * eax]
.no_change:		mov	dword [edi + 8 * ecx], edx
			mov	dword [edi + 8 * ecx + 4], edx
			inc	dword ecx
			cmp	dword ecx, [DECODE_X_END]
			jb	.loop
			ret



;****************************************************************************
;* decode_cycle_border ******************************************************
;****************************************************************************
section .text
decode_cycle_border:
			mov	byte  al, [DECODE_REGISTERS + 020h]
			and	dword eax, 00000000fh
			mov	dword edi, [DECODE_SCREEN]
			mov	dword eax, [ad__transform_table + 4 * eax]
			mov	dword [edi + 8 * ecx], eax
			mov	dword [edi + 8 * ecx + 4], eax
			ret



;****************************************************************************
;* decode_cycle_window_select ***********************************************
;****************************************************************************
section .text
decode_cycle_window_select:
			;-----------------------------
			;decide what we have to decode
			;-----------------------------

			xor	dword eax, eax
			test	byte  [DECODE_REGISTERS + 011h], 020h
			jz	.no_bitmap
			or	byte  al, 004h
.no_bitmap:		test	byte  [DECODE_REGISTERS + 011h], 040h
			jz	.no_ecm
			or	byte  al, 002h
.no_ecm:		test	byte  [DECODE_REGISTERS + 016h], 010h
			jz	.no_mcm
			or	byte  al, 001h
.no_mcm:		mov	dword eax, [.ap__decode_cycle_functions + 4 * eax]
			mov	dword [DECODE_FUNCTION], eax
			ret

				align	4
.ap__decode_cycle_functions:	dd	decode_cycle_window_switch.text
				dd	decode_cycle_window_switch.text_mcm
				dd	decode_cycle_window_switch.text_ecm
				dd	decode_cycle_window_switch.text_ecm_mcm
				dd	decode_cycle_window_switch.bitmap
				dd	decode_cycle_window_switch.bitmap_mcm
				dd	decode_cycle_window_switch.bitmap_ecm
				dd	decode_cycle_window_switch.bitmap_ecm_mcm



;****************************************************************************
;* ad__transform_table ******************************************************
;****************************************************************************
section .text
			align	4
ad__transform_table:	dd	000000000h
			dd	001010101h
			dd	002020202h
			dd	003030303h
			dd	004040404h
			dd	005050505h
			dd	006060606h
			dd	007070707h
			dd	008080808h
			dd	009090909h
			dd	00a0a0a0ah
			dd	00b0b0b0bh
			dd	00c0c0c0ch
			dd	00d0d0d0dh
			dd	00e0e0e0eh
			dd	00f0f0f0fh



;****************************************************************************
;* decode_cycle_window ******************************************************
;****************************************************************************
section .text
decode_cycle_window:
			test	byte  [DECODE_SPRITE_DMA_MASK_LAST], NOT8
			jnz	near  decode_cycle_window_sprites
.no_sprites:		call	dword [DECODE_FUNCTION]

			;-------------------------------------
			;decode data with the above set colors
			;-------------------------------------

			xor	dword eax, eax
			mov	byte  bl, [BASE_FRAME + VICLINE_DATA_CACHE + ebp]
			mov	byte  al, [DECODE_REGISTERS + 016h]
			lea	dword edi, [ab__decode_table + 8 * ebx]
			and	byte  al, 007h
			lea	dword ebp, [DECODE + eax]
			mov	dword eax, [DECODE_COLOR_INDEX0 + 8]
			mov	dword ebx, [DECODE_COLOR_INDEX0 + 12]
			mov	dword [DECODE_COLOR_INDEX0], eax
			mov	dword [DECODE_COLOR_INDEX0 + 4], ebx
			mov	dword ebx, 010101010h
			mov	dword [DECODE_COLOR_INDEX0 + 8], ebx
			mov	dword [DECODE_COLOR_INDEX0 + 12], ebx
			mov	byte  [DECODE_LOOKUP_TABLE1 + 16], cl
			mov	byte  [DECODE_LOOKUP_TABLE2 + 16], cl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX1], dl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX2], ch
			mov	byte  [ebp + VICDECODE_COLOR_INDEX3], dh
			xor	dword eax, eax
			xor	dword ebx, ebx
			xor	dword ecx, ecx
			xor	dword edx, edx
			mov	byte  al, [edi]
			mov	byte  bl, [edi + 4]
			mov	byte  cl, [edi + 1]
			mov	byte  dl, [edi + 5]
			mov	byte  al, [ebp + eax]
			mov	byte  bl, [ebp + ebx]
			mov	byte  cl, [ebp + ecx]
			mov	byte  dl, [ebp + edx]
			mov	byte  al, [DECODE_LOOKUP_TABLE1 + eax]
			mov	byte  bl, [DECODE_LOOKUP_TABLE2 + ebx]
			mov	byte  cl, [DECODE_LOOKUP_TABLE1 + ecx]
			mov	byte  dl, [DECODE_LOOKUP_TABLE2 + edx]
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0], al
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 4], bl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 1], cl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 5], dl
			mov	byte  al, [edi + 2]
			mov	byte  bl, [edi + 6]
			mov	byte  cl, [edi + 3]
			mov	byte  dl, [edi + 7]
			mov	byte  al, [ebp + eax]
			mov	byte  bl, [ebp + ebx]
			mov	byte  cl, [ebp + ecx]
			mov	byte  dl, [ebp + edx]
			mov	byte  al, [DECODE_LOOKUP_TABLE1 + eax]
			mov	byte  bl, [DECODE_LOOKUP_TABLE2 + ebx]
			mov	byte  cl, [DECODE_LOOKUP_TABLE1 + ecx]
			mov	byte  dl, [DECODE_LOOKUP_TABLE2 + edx]
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 2], al
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 6], bl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 3], cl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 7], dl
			ret

decode_cycle_window_switch:

			;-----------------------------
			;set colors for hires textmode
			;-----------------------------

.text:			xor	dword ebx, ebx
			mov	byte  cl, [DECODE_REGISTERS + 021h]
			mov	byte  dl, [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ebp]
			and	byte  cl, 00fh
			and	byte  dl, 00fh
			ret

			;-----------------------
			;set colors for mcm text
			;-----------------------

.text_mcm:		test	byte  [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], 008h
			jz	.text
			mov	byte  dh, [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ebp]
			mov	byte  cl, [DECODE_REGISTERS + 021h]
			mov	byte  dl, [DECODE_REGISTERS + 022h]
			mov	byte  ch, [DECODE_REGISTERS + 023h]
			and	dword ecx, 00f0fh
			xor	dword ebx, ebx
			and	dword edx, 0070fh
			inc	byte  bh
			ret

			;-----------------------
			;set colors for ecm text
			;-----------------------

.text_ecm:		xor	dword edx, edx
			xor	dword ebx, ebx
			mov	byte  dl, [BASE_FRAME + VICLINE_VIDEO_CACHE + ebp]
			shr	byte  dl, 6
			mov	byte  cl, [DECODE_REGISTERS + 021h + edx]
			mov	byte  dl, [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ebp]
			and	byte  cl, 00fh
			and	byte  dl, 00fh
			ret

			;---------------------------
			;set colors for hires bitmap
			;---------------------------

.bitmap:		mov	byte  cl, [BASE_FRAME + VICLINE_VIDEO_CACHE + ebp]
			mov	byte  dl, cl
			and	byte  cl, 00fh
			shr	byte  dl, 4
			xor	dword ebx, ebx
			ret

			;-------------------------
			;set colors for mcm bitmap
			;-------------------------

.bitmap_mcm:		mov	byte  cl, [DECODE_REGISTERS + 021h]
			mov	byte  dl, [BASE_FRAME + VICLINE_VIDEO_CACHE + ebp]
			mov	byte  ch, dl
			shr	byte  dl, 4
			mov	byte  dh, [BASE_FRAME + VICLINE_COLOR_RAM_CACHE + ebp]
			and	dword ecx, 00f0fh
			xor	dword ebx, ebx
			and	dword edx, 00f0fh
			inc	byte  bh
			ret

			;-------------------------------------------
			;set colors for illegal modes (always black)
			;-------------------------------------------

.text_ecm_mcm:
.bitmap_ecm:
.bitmap_ecm_mcm:	xor	dword ebx, ebx
			xor	dword ecx, ecx
			xor	dword edx, edx
			test	byte  [DECODE_REGISTERS + 016h], 010h
			setnz	byte  bh
			ret

decode_cycle_window_sprites:
			mov	byte  [DECODE_LINE_CYCLE], cl

			;------------------------------
			;move Scrollbuffer and Z-Buffer
			;------------------------------

			mov	dword eax, [DECODE_COLOR_INDEX0 + 8]
			mov	dword ebx, [DECODE_COLOR_INDEX0 + 12]
			mov	dword ecx, [DECODE_Z_BUFFER + 8]
			mov	dword edx, [DECODE_Z_BUFFER + 12]
			mov	dword [DECODE_COLOR_INDEX0], eax
			mov	dword [DECODE_COLOR_INDEX0 + 4], ebx
			mov	dword [DECODE_Z_BUFFER], ecx
			mov	dword [DECODE_Z_BUFFER + 4], edx
			mov	dword eax, 010101010h
			xor	dword ebx, ebx
			xor	dword edx, edx
			xor	dword ecx, ecx
.correct_z_buffer:	mov	byte  dl, [DECODE_COLOR_INDEX0 + ecx]
			cmp	byte  dl, al
			jne	.z_buffer_ok
			mov	byte  [DECODE_Z_BUFFER + ecx], bl
.z_buffer_ok:		inc	dword ecx
			cmp	byte  cl, 008h
			jb	.correct_z_buffer
			mov	dword [DECODE_COLOR_INDEX0 + 8], eax
			mov	dword [DECODE_COLOR_INDEX0 + 12], eax
			mov	dword [DECODE_Z_BUFFER + 8], ebx
			mov	dword [DECODE_Z_BUFFER + 12], ebx

			;-------------------------
			;decode background sprites
			;-------------------------

			mov	byte  al, [DECODE_REGISTERS + 01bh]
			push	dword ebp
			and	byte  al, [DECODE_SPRITE_DMA_MASK_LAST]
			mov	byte  [DECODE_SPRITE_Z_LAYER], 000h
			call	decode_cycle_sprite
			pop	dword ebp

			;------------------
			;decode text window
			;------------------

			call	dword [DECODE_FUNCTION]
			xor	dword eax, eax
			mov	byte  bl, [BASE_FRAME + VICLINE_DATA_CACHE + ebp]
			mov	byte  al, [DECODE_REGISTERS + 016h]
			lea	dword edi, [ab__decode_table + 8 * ebx]
			and	byte  al, 007h
			lea	dword ebp, [DECODE + eax]
			mov	byte  [DECODE_LOOKUP_TABLE1 + 16], cl
			mov	byte  [DECODE_LOOKUP_TABLE2 + 16], cl
			mov	byte  [DECODE_Z_LAYER], 008h
			call	decode_pixel_block

			;-------------------------
			;decode foreground sprites
			;-------------------------

			mov	byte  al, [DECODE_REGISTERS + 01bh]
			mov	byte  bl, 009h
			xor	byte  al, NOT8
			push	dword ebp
			and	byte  al, [DECODE_SPRITE_DMA_MASK_LAST]
			mov	byte  [DECODE_SPRITE_Z_LAYER], bl
			call	decode_cycle_sprite
			pop	dword ebp

			xor	dword eax, eax
			xor	dword ebx, ebx
			xor	dword ecx, ecx
			xor	dword edx, edx
			mov	byte  al, [ebp + VICDECODE_COLOR_INDEX0]
			mov	byte  bl, [ebp + VICDECODE_COLOR_INDEX0 + 4]
			mov	byte  cl, [ebp + VICDECODE_COLOR_INDEX0 + 1]
			mov	byte  dl, [ebp + VICDECODE_COLOR_INDEX0 + 5]
			mov	byte  al, [DECODE_LOOKUP_TABLE1 + eax]
			mov	byte  bl, [DECODE_LOOKUP_TABLE2 + ebx]
			mov	byte  cl, [DECODE_LOOKUP_TABLE1 + ecx]
			mov	byte  dl, [DECODE_LOOKUP_TABLE2 + edx]
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0], al
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 4], bl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 1], cl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 5], dl
			mov	byte  al, [ebp + VICDECODE_COLOR_INDEX0 + 2]
			mov	byte  bl, [ebp + VICDECODE_COLOR_INDEX0 + 6]
			mov	byte  cl, [ebp + VICDECODE_COLOR_INDEX0 + 3]
			mov	byte  dl, [ebp + VICDECODE_COLOR_INDEX0 + 7]
			mov	byte  al, [DECODE_LOOKUP_TABLE1 + eax]
			mov	byte  bl, [DECODE_LOOKUP_TABLE2 + ebx]
			mov	byte  cl, [DECODE_LOOKUP_TABLE1 + ecx]
			mov	byte  dl, [DECODE_LOOKUP_TABLE2 + edx]
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 2], al
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 6], bl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 3], cl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 7], dl
			ret

decode_pixel_block:
			mov	byte  [ebp + VICDECODE_COLOR_INDEX1], dl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX2], ch
			mov	byte  [ebp + VICDECODE_COLOR_INDEX3], dh
			xor	dword eax, eax
			xor	dword ebx, ebx
			xor	dword ecx, ecx
			xor	dword edx, edx
			mov	byte  dh, [DECODE_Z_LAYER]
			mov	byte  al, VICDECODE_COLOR_INDEX0
			mov	byte  bl, (VICDECODE_COLOR_INDEX0 + 4)
			mov	byte  cl, (VICDECODE_COLOR_INDEX0 + 1)
			mov	byte  dl, (VICDECODE_COLOR_INDEX0 + 5)
			cmp	byte  dh, [ebp + VICDECODE_Z_BUFFER]
			jb	.skip1
			mov	byte  [ebp + VICDECODE_Z_BUFFER], dh
			mov	byte  al, [edi]
.skip1:			cmp	byte  dh, [ebp + VICDECODE_Z_BUFFER + 4]
			jb	.skip2
			mov	byte  [ebp + VICDECODE_Z_BUFFER + 4], dh
			mov	byte  bl, [edi + 4]
.skip2:			cmp	byte  dh, [ebp + VICDECODE_Z_BUFFER + 1]
			jb	.skip3
			mov	byte  [ebp + VICDECODE_Z_BUFFER + 1], dh
			mov	byte  cl, [edi + 1]
.skip3:			cmp	byte  dh, [ebp + VICDECODE_Z_BUFFER + 5]
			jb	.skip4
			mov	byte  [ebp + VICDECODE_Z_BUFFER + 5], dh
			mov	byte  dl, [edi + 5]
.skip4:			xor	byte  dh, dh
			mov	byte  al, [ebp + eax]
			mov	byte  bl, [ebp + ebx]
			mov	byte  cl, [ebp + ecx]
			mov	byte  dl, [ebp + edx]
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0], al
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 4], bl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 1], cl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 5], dl

			mov	byte  dh, [DECODE_Z_LAYER]
			mov	byte  al, (VICDECODE_COLOR_INDEX0 + 2)
			mov	byte  bl, (VICDECODE_COLOR_INDEX0 + 6)
			mov	byte  cl, (VICDECODE_COLOR_INDEX0 + 3)
			mov	byte  dl, (VICDECODE_COLOR_INDEX0 + 7)
			cmp	byte  dh, [ebp + VICDECODE_Z_BUFFER + 2]
			jb	.skip5
			mov	byte  [ebp + VICDECODE_Z_BUFFER + 2], dh
			mov	byte  al, [edi + 2]
.skip5:			cmp	byte  dh, [ebp + VICDECODE_Z_BUFFER + 6]
			jb	.skip6
			mov	byte  [ebp + VICDECODE_Z_BUFFER + 6], dh
			mov	byte  bl, [edi + 6]
.skip6:			cmp	byte  dh, [ebp + VICDECODE_Z_BUFFER + 3]
			jb	.skip7
			mov	byte  [ebp + VICDECODE_Z_BUFFER + 3], dh
			mov	byte  cl, [edi + 3]
.skip7:			cmp	byte  dh, [ebp + VICDECODE_Z_BUFFER + 7]
			jb	.skip8
			mov	byte  [ebp + VICDECODE_Z_BUFFER + 7], dh
			mov	byte  dl, [edi + 7]
.skip8:			xor	byte  dh, dh
			mov	byte  al, [ebp + eax]
			mov	byte  bl, [ebp + ebx]
			mov	byte  cl, [ebp + ecx]
			mov	byte  dl, [ebp + edx]
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 2], al
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 6], bl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 3], cl
			mov	byte  [ebp + VICDECODE_COLOR_INDEX0 + 7], dl
			ret

decode_cycle_sprite:
			mov	dword ebx, 000000007h
.loop:			shl	byte  al, 1
			jnc	near  .sprite_off
			xor	dword ecx, ecx
			mov	byte  ah, [.bit_table + ebx]
			mov	byte  cl, [DECODE_REGISTERS + 2 * ebx]
			test	byte  [DECODE_REGISTERS + 010h], ah
			setnz	byte  ch
			add	dword ecx, 060h
			and	byte  ch, 001h
			mov	dword ebp, ecx
			xor	dword edx, edx
			shr	dword ecx, 3
			mov	byte  dl, [DECODE_LINE_CYCLE]
			and	dword ebp, 007h
			sub	byte  dl, cl
			test	byte  [DECODE_REGISTERS + 01dh], ah
			jnz	.expanded_sprite
			cmp	dword edx, 003h
			jb	.sprite_on
			jmp	.sprite_off
.expanded_sprite:	cmp	dword edx, 006h
			jae	near  .sprite_off
			shr	dword edx, 1
			setc	byte  al
.sprite_on:		push	dword eax
			push	dword ebx
			mov	dword ecx, [DECODE_FRAME_OFFSET]
			cmp	byte  bl, 002h
			ja	.this_line
			mov	dword ecx, [DECODE_FRAME_OFFSET_LAST]
.this_line:		add	dword edx, ecx
			xor	dword ecx, ecx
			test	byte  [DECODE_REGISTERS + 01ch], ah
			setnz	byte  ch
			lea	dword ebp, [DECODE + ebp]
			lea	dword edx, [edx + 4 * ebx]
			mov	byte  cl, [BASE_FRAME + VICLINE_SPRITE_CACHE + edx]
			test	byte  [DECODE_REGISTERS + 01dh], ah
			jz	.no_x_expand
			xor	dword edx, edx
			test	byte  al, al
			jnz	.low_nibble
			shr	byte  cl, 4
.low_nibble:		and	byte  cl, 00fh
			mov	byte  dl, cl
			test	byte  ch, ch
			jz	.no_mcm_1
			add	byte  dl, 010h
.no_mcm_1:		mov	byte  cl, [.ab__expand_table + edx]
.no_x_expand:		mov	byte  al, 007h
			sub	byte  al, bl
			lea	dword edi, [ab__decode_table + 8 * ecx]
			add	byte  al, [DECODE_SPRITE_Z_LAYER]
			mov	byte  dl, [DECODE_REGISTERS + 027h + ebx]
			mov	byte  [DECODE_Z_LAYER], al
			test	byte  [DECODE_REGISTERS + 01ch], ah
			jz	.no_mcm
			mov	byte  dl, [DECODE_REGISTERS + 025h]
			mov	byte  ch, [DECODE_REGISTERS + 027h + ebx]
			mov	byte  dh, [DECODE_REGISTERS + 026h]
			and	byte  ch, 00fh
.no_mcm:		and	dword edx, 00f0fh
			call	decode_pixel_block
			pop	dword ebx
			pop	dword eax
.sprite_off:		dec	dword ebx
			jns	near  .loop
			ret

.bit_table:		db	001h, 002h, 004h, 008h
			db	010h, 020h, 040h, 080h
.ab__expand_table:
.hires:			db	000h, 003h, 00ch, 00fh
			db	030h, 033h, 03ch, 03fh
			db	0c0h, 0c3h, 0cch, 0cfh
			db	0f0h, 0f3h, 0fch, 0ffh
.mcm:			db	000h, 005h, 00ah, 00fh
			db	050h, 055h, 05ah, 05fh
			db	0a0h, 0a5h, 0aah, 0afh
			db	0f0h, 0f5h, 0fah, 0ffh



;****************************************************************************
;* decode_cycle_window_left *************************************************
;****************************************************************************
section .text
decode_cycle_window_left:
			mov	dword ebp, [DECODE_FRAME_OFFSET]
			mov	dword eax, 010101010h
			lea	dword ebp, [ebp + ecx - 15]
			push	dword ebx
			mov	dword [DECODE_COLOR_INDEX0 + 8], eax
			push	dword ecx
			mov	dword [DECODE_COLOR_INDEX0 + 12], eax
			test	byte  [DECODE_REGISTERS + 016h], 007h
			jz	.no_extra_video_byte
			call	decode_cycle_window.no_sprites
.no_extra_video_byte:	mov	dword ebp, [DECODE_FRAME_OFFSET]
			mov	dword ecx, [esp]
			mov	dword ebx, [esp + 4]
			lea	dword ebp, [ebp + ecx - 14]
			call	decode_cycle_window
			mov	dword edi, [DECODE_SCREEN]
			pop	dword ecx
			pop	dword ebx
			test	byte  [DECODE_REGISTERS + 016h], 008h
			jnz	near  decode_cycle_window_central.full
			mov	byte  al, [DECODE_REGISTERS + 020h]
			and	dword eax, 00000000fh
			mov	dword eax, [ad__transform_table + 4 * eax]
			mov	dword [edi + 8 * ecx], eax
			mov	byte  al, [DECODE_COLOR_INDEX0 + 7]
			ror	dword eax, 8
			mov	dword [edi + 8 * ecx + 4], eax
			ret



;****************************************************************************
;* decode_cycle_window_right1 ***********************************************
;****************************************************************************
section .text
decode_cycle_window_right1:
			test	byte  [DECODE_REGISTERS + 016h], 008h
			jnz	decode_cycle_window_central
			mov	dword ebp, [DECODE_FRAME_OFFSET]
			push	dword ebx
			push	dword ecx
			lea	dword ebp, [ebp + ecx - 14]
			call	decode_cycle_window
			mov	dword edi, [DECODE_SCREEN]
			pop	dword ecx
			pop	dword ebx
			mov	dword eax, [DECODE_COLOR_INDEX0]
			mov	dword edx, [DECODE_COLOR_INDEX0 + 4]
			mov	dword [edi + 8 * ecx], eax
			shl	dword edx, 8
			mov	byte  dl, [DECODE_REGISTERS + 020h]
			and	byte  dl, 00fh
			ror	dword edx, 8
			mov	dword [edi + 8 * ecx + 4], edx
			ret



;****************************************************************************
;* decode_cycle_window_right2 ***********************************************
;****************************************************************************
section .text
decode_cycle_window_right2:
			test	byte  [DECODE_REGISTERS + 016h], 008h
			jz	near  decode_cycle_border



;****************************************************************************
;* decode_cycle_window_central **********************************************
;****************************************************************************
section .text
decode_cycle_window_central:
			mov	dword ebp, [DECODE_FRAME_OFFSET]
			push	dword ebx
			push	dword ecx
			lea	dword ebp, [ebp + ecx - 14]
			call	decode_cycle_window
			mov	dword edi, [DECODE_SCREEN]
			pop	dword ecx
			pop	dword ebx
.full:			mov	dword eax, [DECODE_COLOR_INDEX0]
			mov	dword edx, [DECODE_COLOR_INDEX0 + 4]
			mov	dword [edi + 8 * ecx], eax
			mov	dword [edi + 8 * ecx + 4], edx
			ret
;******************************************************** ec64@unusedino.de *

