/****************************************************************************
 ****************************************************************************
 *
 * fcntl.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef EC64SYS_FCNTL_H
#define EC64SYS_FCNTL_H

#define O_RDONLY	000000
#define O_WRONLY	000001
#define O_RDWR		000002
#define O_ACCMODE	000003
#define O_CREAT		000100
#define O_EXCL		000200
#define O_NOCTTY	000400
#define O_TRUNC		001000
#define O_APPEND	002000
#define O_NONBLOCK	004000
#define O_NDELAY	O_NONBLOCK
#define O_SYNC		010000
#define FASYNC		020000
#define O_DIRECT	040000
#define O_LARGEFILE	100000
#define O_DIRECTORY	200000
#define O_NOFOLLOW	400000

#define F_DUPFD		0
#define F_GETFD		1
#define F_SETFD		2
#define F_GETFL		3
#define F_SETFL		4
#define F_GETLK		5
#define F_SETLK		6
#define F_SETLKW	7
#define F_SETOWN	8
#define F_GETOWN	9

#define SEEK_SET	0
#define SEEK_CUR	1
#define SEEK_END	2

#define STDIN		0
#define STDOUT		1
#define STDERR		2



#endif
/******************************************************** ec64@unusedino.de */

