;****************************************************************************
;****************************************************************************
;*
;* memory.n
;*
;****************************************************************************
;****************************************************************************





%define MEMORY_N
%include "memory.i"



;****************************************************************************
;* memory_fill **************************************************************
;****************************************************************************
;* [1]=>  pointer to data
;* [2]=>  length
;* [3]=>  value
;****************************************************************************
section .text
memory_fill:
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: optimize for dword access
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			push	dword eax
			push	dword ecx
			push	dword edi
			mov	dword edi, [esp + 16]
			mov	dword ecx, [esp + 20]
			mov	dword eax, [esp + 24]
			test	dword ecx, ecx
			jz	.end
			cld
			rep stosb
.end:			pop	dword edi
			pop	dword ecx
			pop	dword eax
			ret

ec64io_memory_fill:	equ	memory_fill



;****************************************************************************
;* memory_copy **************************************************************
;****************************************************************************
;* [1]=>  destination
;* [2]=>  source
;* [3]=>  length
;****************************************************************************
section .text
memory_copy:
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: optimize for dword access
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			push	dword ecx
			push	dword esi
			push	dword edi
			mov	dword edi, [esp + 16]
			mov	dword esi, [esp + 20]
			mov	dword ecx, [esp + 24]
			test	dword ecx, ecx
			jz	.end
			cld
			rep movsb
.end:			pop	dword edi
			pop	dword esi
			pop	dword ecx
			ret

ec64io_memory_copy:	equ	memory_copy
;******************************************************** ec64@unusedino.de *

