;****************************************************************************
;****************************************************************************
;*
;* defines.i
;*
;****************************************************************************
;****************************************************************************





%ifndef DEFINES_I
%define DEFINES_I




;****************************************************************************
;****************************************************************************
;*
;* PART 1: global settings
;*
;****************************************************************************
;****************************************************************************





%assign C64_CLOCK		982800	;Hz = 50 (frames/s) * 312 (lines/frame) * 63 (cycles/line)
%assign C1541_CLOCK		995134	;Hz





;****************************************************************************
;****************************************************************************
;*
;* PART 2.1: module settings
;*
;****************************************************************************
;****************************************************************************





;%define CORE_ENABLE_BP

;%define C64MEMORY_ASSERTION
;%define C64MEMORY_ASSERTION_STACK

;%define CPU65XX_DISABLE_ILLEGAL_OPCODES
;%define CPU65XX_USE_RESET_ADDRESS			01000h
;%define CPU65XX_ENABLE_BP

;%define VIC6569_DISABLE_SELECTIVE_DECODING
%define VIC6569_DISABLE_LINEWISE_DECODING
%define VIC6569_ASSERTION
%define VIC6569_ASSERTION_CHANGE_LOG_WRITE
%define VIC6569_ASSERTION_CHANGE_LOG_OVERFLOW
%define VIC6569_ASSERTION_DECODE_LINE_COUNTER

;%define C1541MEMORY_ASSERTION
;%define C1541MEMORY_ASSERTION_STACK
;%define C1541MEMORY_ASSERTION_KERNEL





;****************************************************************************
;****************************************************************************
;*
;* PART 2.2: process the global settings
;*
;****************************************************************************
;****************************************************************************





%ifdef EC64_ENABLE_BP_SUPPORT
%define CORE_ENABLE_BP
%define CPU65XX_ENABLE_BP
%else
%undef CORE_ENABLE_BP
%undef CPU65XX_ENABLE_BP
%endif



%endif
;******************************************************** ec64@unusedino.de *

