;****************************************************************************
;****************************************************************************
;*
;* fb.i
;*
;****************************************************************************
;****************************************************************************





%ifndef EC64SYS_FB_I
%define EC64SYS_FB_I

%assign FBIOGET_VSCREENINFO	04600h
%assign FBIOPUT_VSCREENINFO	04601h
%assign FBIOGETCMAP		04604h
%assign FBIOPUTCMAP		04605h

%assign FB_ACTIVATE_NOW		0	;set values immediately (or vbl)
%assign FB_ACTIVATE_NXTOPEN	1	;activate on next open
%assign FB_ACTIVATE_TEST	2	;don't set, round up impossible
%assign FB_ACTIVATE_MASK	15	;values
%assign FB_ACTIVATE_VBL		16	;activate values on next vbl
%assign FB_CHANGE_CMAP_VBL	32	;change colormap on vbl
%assign FB_ACTIVATE_ALL		64	;change all VCs on this fb

%assign FB_ACCELF_TEXT		1	;text mode acceleration

%assign FB_SYNC_HOR_HIGH_ACT	1	;horizontal sync high active
%assign FB_SYNC_VERT_HIGH_ACT	2	;vertical sync high active
%assign FB_SYNC_EXT		4	;external sync
%assign FB_SYNC_COMP_HIGH_ACT	8	;composite sync high active
%assign FB_SYNC_BROADCAST	16	;broadcast video timings
					;vtotal = 144d/288n/576i => PAL
					;vtotal = 121d/242n/484i => NTSC
%assign FB_SYNC_ON_GREEN	32	;sync on green

%assign FB_VMODE_NONINTERLACED  0	;non interlaced
%assign FB_VMODE_INTERLACED	1	;interlaced
%assign FB_VMODE_DOUBLE		2	;double scan
%assign FB_VMODE_MASK		255

%assign FB_VMODE_YWRAP		256	;ywrap instead of panning
%assign FB_VMODE_SMOOTH_XPAN	512	;smooth xpan possible (kernel internally used)
%assign FB_VMODE_CONUPDATE	512	;don't update x/yoffset



				struc	tcmap
				alignb	4
d__cmap_offset:			resd	1
d__cmap_length:			resd	1
p__cmap_red:			resd	1
p__cmap_green:			resd	1
p__cmap_blue:			resd	1
p__cmap_transparent:		resd	1
				endstruc



				struc	tscreen
				alignb	4
d__screen_x_resolution:		resd	1
d__screen_y_resolution:		resd	1
d__screen_virtual_x_resolution:	resd	1
d__screen_virtual_y_resolution:	resd	1
d__screen_x_offset:		resd	1
d__screen_y_offset:		resd	1
d__screen_bits_per_pixel:	resd	1
d__screen_grayscale:		resd	1
d__screen_red_offset:		resd	1
d__screen_red_length:		resd	1
d__screen_red_msb_right:	resd	1
d__screen_green_offset:		resd	1
d__screen_green_length:		resd	1
d__screen_green_msb_right:	resd	1
d__screen_blue_offset:		resd	1
d__screen_blue_length:		resd	1
d__screen_blue_msb_right:	resd	1
d__screen_transparent_offset:	resd	1
d__screen_transparent_length:	resd	1
d__screen_transparent_msb_right:resd	1
d__screen_non_standard_format:	resd	1
d__screen_activate:		resd	1
d__screen_height:		resd	1
d__screen_width:		resd	1
d__screen_acceleration_flags:	resd	1
d__screen_pixel_clock:		resd	1
d__screen_left_margin:		resd	1
d__screen_right_margin:		resd	1
d__screen_upper_margin:		resd	1
d__screen_lower_margin:		resd	1
d__screen_hsync_length:		resd	1
d__screen_vsync_length:		resd	1
d__screen_sync:			resd	1
d__screen_vmode:		resd	1
ad__screen_reserved:		resd	6
				endstruc



%endif
;******************************************************** ec64@unusedino.de *

