;****************************************************************************
;****************************************************************************
;*
;* tty.i
;*
;****************************************************************************
;****************************************************************************





%ifndef EC64SYS_TTY_I
%define EC64SYS_TTY_I

%assign TCGETS			05401h
%assign TCSETS			05402h
%assign TCSETSW			05403h
%assign TIOCLINUX		0541ch

%assign VT_OPENQRY		05600h
%assign VT_GETMODE		05601h
%assign VT_SETMODE		05602h
%assign 	VT_AUTO		0
%assign 	VT_PROCESS	1
%assign 	VT_ACKACQ	2
%assign VT_GETSTATE		05603h
%assign VT_SENDSIG 		05604h
%assign VT_RELDISP		05605h
%assign VT_ACTIVATE		05606h
%assign VT_WAITACTIVE		05607h
%assign VT_DISALLOCATE		05608h
%assign VT_RESIZE		05609h
%assign VT_RESIZEX		0560ah
%assign VT_LOCKSWITCH		0560bh
%assign VT_UNLOCKSWITCH		0560ch

%assign KDGETLED		04b31h
%assign KDSETLED		04b32h
%assign KDSETMODE		0x4b3a
%assign KDGETMODE		0x4b3b
%assign KDGKBMODE		04b44h
%assign KDSKBMODE		04b45h
%assign KDGKBENT		04b46h

%assign KD_TEXT			0
%assign KD_GRAPHICS		1

%assign K_RAW			000h
%assign K_XLATE			001h
%assign K_MEDIUMRAW		002h

%assign NR_KEYS			128

%assign KG_SHIFT		0
%assign KG_ALTGR		1
%assign KG_CTRL			2
%assign KG_ALT			3
%assign KG_SHIFTL		4
%assign KG_SHIFTR		5
%assign KG_CTRLL		6
%assign KG_CTRLR		7
%assign KG_CAPSSHIFT		8

;input flags
%assign ISTRIP			000400q
%assign INLCR			000100q
%assign IGNCR			000200q
%assign ICRNL			000400q
%assign IXON			002000q
%assign IXOFF			010000q

;local flags
%assign ISIG			1
%assign ICANON			2
%assign ECHO			8

;control characters
%assign VINTR			0
%assign VQUIT			1
%assign VERASE			2
%assign VKILL			3
%assign VEOF			4
%assign VTIME			5
%assign VMIN			6
%assign VSWTC			7
%assign VSTART			8
%assign VSTOP			9
%assign VSUSP			10
%assign VEOL			11
%assign VREPRINT		12
%assign VDISCARD		13
%assign VWERASE			14
%assign VLNEXT			15
%assign VEOL2			16



				struc	ttermios
				alignb	4
d__termios_input_flags:		resd	1
d__termios_output_flags:	resd	1
d__termios_control_flags:	resd	1
d__termios_local_flags:		resd	1
b__termios_line_discipline:	resb	1
ab__termios_control_characters:	resb	64
				endstruc

				struc	tvtmode
				alignb	4
b__vtmode_mode:			resb	1
b__vtmode_waitv:		resb	1
b__vtmode_relsig:		resb	1
b__vtmode_acqsig:		resb	1
b__vtmode_frsig:		resb	1
				endstruc

				struc	tkbentry
				alignb	4
b__kbentry_table:		resb	1
b__kbentry_index:		resb	1
w__kbentry_value:		resw	1
				endstruc



%endif
;******************************************************** ec64@unusedino.de *

