/****************************************************************************
 ****************************************************************************
 *
 * draw.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef DRAW_H
#define DRAW_H

#include "defines.h"
#include "ec64types.h"

#define DRAW_X_CHARACTER_SIZE		8
#define DRAW_Y_CHARACTER_SIZE		8
#define DRAW_X_LED_SIZE			8
#define DRAW_Y_LED_SIZE			2

extern void				draw_initialize(void);
extern void				draw_text(const b *, const d, const b *);
extern void				draw_led(const b *, const d, const d);
extern void				draw_plane(const b *, const b *, const d);
extern void				draw_planes(const b *, const b *, const d, const d, const d);



#endif
/******************************************************** ec64@unusedino.de */

