/****************************************************************************
 ****************************************************************************
 *
 * fb.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef FB_H
#define FB_H

#include "defines.h"
#include "ec64types.h"
#include "video.h"

#define FB_PATH1			"/dev/fb0"
#define FB_PATH2			"/dev/fb/0"
#define FB_PATH3			"/dev/fb1"
#define FB_PATH4			"/dev/fb/1"

const sd				fb_initialize(tvidinit *);
void					fb_restore(void);
void					fb_set_path(const b *);
void					fb_set_options(tvidinit *);
void					fb_draw_text(const d, const d, const b *);
void					fb_draw_led(const d, const d, const b);
void					fb_draw_c64_screen(void);
void					fb_area_clear(const d, const d, const d, const d);
void					fb_area_move(const d, const d, const d, const d, const d, const d);
#ifdef FB_ENABLE_SCREENSHOT_SUPPORT
void					fb_get_line(b *, const d, const d);
#endif



#endif
/******************************************************** ec64@unusedino.de */

