/****************************************************************************
 ****************************************************************************
 *
 * sync.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef SYNC_H
#define SYNC_H

#include "defines.h"
#include "ec64types.h"

#define SYNC_TIME_TABLE_SIZE	32
#define SYNC_MAX_FRAME_TIME	(0x7fffffff / SYNC_TIME_TABLE_SIZE)
#define SYNC_FRAME_TIME		20000
#define SYNC_SLEEP_TIME		5000

extern void				sync_initialize(void);
extern void				sync_restore(void);
extern const d				sync_frame_time(void);
extern void				sync_get_time(void);
extern d				sync_delay(d);
extern void				sync_sleep(void);



#endif
/******************************************************** ec64@unusedino.de */

